/* Module de calcul de la transformee ondelettes continue */

/* Bertrand GUIHENEUF - FRACTALES 10/1996 */ 

#include "CWT1D_WTransform.h"
#include "CWT1D_Filter.h"
#include "CWT1D_Wavelet.h"
#include "CWT1D_Convol.h"
#include <math.h>

#ifndef NULL
#define NULL 0
#endif


void CWT1D_WT(ent, taille, sor_reel, sor_complex, Psi, Filtre, a_min, a_max, nb_a)
     double *ent;
     int taille;
     double *sor_reel;
     double *sor_complex;
     CWT1D_t_Ondelette *Psi;
     CWT1D_t_Filtre *Filtre;
     double a_min;
     double a_max;
     int nb_a;
/* calcul de la trasformee a toutes les echelles */
{

    double a, a_inc, la, lamin, lamax;
    int ech; /* compteur de l'echelle */

    
    lamin = log(a_min);
    lamax = log(a_max);
    a_inc = (lamax-lamin)/(double)(nb_a-1); /* increment entre deux echelles */
    la = lamin;a = exp(la);

    for (ech=0; ech<nb_a; ech++)
	{
	  a = exp(la);
	    /* d'abord creer le filtre de l'echelle courante */
	    CWT1D_CreerFiltreReel( Psi, Filtre, a ); 
	    /* ensuite on convolue sur toute la ligne */
	    CWT1D_Filtrage( ent, &(sor_reel[ech*taille]), taille, Filtre, CWT1D_Periodisation );
	    /* passage a l'ehelle suivante */
	    la += a_inc;
	}


    if (sor_complex != NULL)
	{

	   la = lamin; /* echelle courante */ 

	  for (ech=0; ech<nb_a; ech++)
	      {
		a = exp(la);
		/* d'abord creer le filtre de l'echelle courante */
		CWT1D_CreerFiltreComplexe( Psi, Filtre, a ); 
		/* ensuite on convolue sur toute la ligne */
		CWT1D_Filtrage( ent, &(sor_complex[ech*taille]), taille, Filtre, CWT1D_Periodisation );
		/* passage a l'ehelle suivante */
		la += a_inc;
	      }
	  
	}
}




long CWT1D_Taille_WT(Taille, nb_a)
     int Taille;
     int nb_a;
/* Renvoie la taille de la transformee ondelettes */
{

    return( (long)Taille * (long)nb_a);

}


    


