/* Library to add C-Functions to Scilab And/Or Matlab */
/* Bertrand Guiheneuf 1996 */






#ifndef INCLUDE_CSCIINTERF
#define INCLUDE_CSCIINTERF

#include <string.h>
#include <stdio.h>
#include <stdlib.h>


#ifndef MAX
#define MAX(a,b) (a > b ? a : b)
#endif

#ifndef MIN
#define MIN(a,b) (a < b ? a : b)
#endif



#ifdef C_SCILAB


#include "machine.h"


#ifndef integer
#define integer int
#endif

/* types definition */ 
typedef double Matrix; 


/* the internal of SCILAB */

extern struct {
  double  stk[2];
} stack_;


extern struct {
  integer bot, top, idstk[3000]	, lstk[500], leps, 
    bbot, bot0, infstk[500];
} vstk_;



extern struct {
  integer ids[1536] , pstk[256], rstk[256], pt, niv, 
    macr, paus, icall;
} recu_;


extern struct {
  integer ddt, err, lct[8], lin[8192], lpt[6], hio, rio, wio, rte, wte;
} iop_;



extern struct {
  integer err1, err2, errct, toperr;
} errgst_;



extern struct {
  integer sym, syn[6], char1, fin, fun, lhs, rhs, ran[2], comp[2];
} com_;



extern struct {
  char alfa[63], alfb[63], buf[4096];
} cha1_;



extern struct {
  integer nlink;
} link1_;



extern struct {
  char tablin[1000];
} link2_;



extern struct {
  integer wmac, lcntr, nmacs, macnms[120], lgptrs[21],
    bptlg[100];
} dbg_;


extern void cout();
extern void C2F(cvstr)();

#endif /* C_SCILAB */






#ifdef C_MATLAB4

#include "mex.h"
#define C2F(nom) nom

#endif /* C_MATLAB4 */


 

#ifdef C_MATLAB

#include "mex.h"

#define C2F(nom) nom
#define Matrix mxArray 

#endif /* C_MATLAB */




#ifndef C_LAB_INTERF_CPP
extern struct {
  int NbParamIn;
  int NbParamOut;
  int ReturnCounter;
  int FuncIndex;
  int ReturnIndex;
  char Retour[1000];
  int Err;
  Matrix **Param;
  Matrix **Return;
} Interf;
#else

struct {
  int NbParamIn;
  int NbParamOut;
  int ReturnCounter;
  int FuncIndex;
  int ReturnIndex;
  char Retour[1000];
  int Err;
  Matrix **Param;
  Matrix **Return;
} Interf;

#endif


/****************************************** P R O T O T Y P E S *************************************/


void InterfError();
extern int MatrixMemSize();
extern Matrix *MatrixCreate();
extern int MatrixIsNumeric();
extern int MatrixIsReal();
extern int MatrixIsComplex();
extern int MatrixIsScalar();
extern Matrix *MatrixCreateString();
extern char *MatrixReadString();
extern void MatrixFree();
extern double *MatrixGetPr();
extern double *MatrixGetPi();
extern int MatrixGetWidth();
extern int MatrixGetHeight();
extern double MatrixGetScalar();
extern void MatrixTranspose();
extern void MatrixCopy();
extern void ReturnParam();
extern void InterfInit();
extern void InterfDone();



#endif /*INCLUDE_CSCIINTERF*/ 
