/*-----------------------------------------------------------------------------
*                                                                              
*                                    FracLab
*                                                                              
*------------------------------------------------------------------------------
*                                                                              
* File path        : /home/canus/MFA.CMP/MFAG.CL/inc/MFAG_continuous1d.h
* File type        : C header file
* Revision         : $Revision: 1.1.1.1 $
* RCS status       : $Id: MFAG_continuous1d.h,v 1.1.1.1 1999/02/10 13:38:44 guiheneu Exp $
* Created by       : (Fractales Project INRIA) Christophe Canus
* Creation date    : Sun Feb  7 16:43:33 1999
* Last edited by   : (Fractales Project INRIA) Christophe Canus
* Last edition date: Sun Feb  7 16:43:34 1999
*                                                                              
*------------------------------------------------------------------------------
*                                                                              
* Description : 
*                
*                
*                
*------------------------------------------------------------------------------
*/

/* Christophe Canus 1996-98 */

#ifndef _MFAG_continuous1d_h_
#define _MFAG_continuous1d_h_
#include "MFAM_kernel.h"
#include "MFAG_misc.h"
#include "MFAG_hoelder1d.h"

/*****************************************************************************/
/*****************************************************************************/
/* horizontal sections                                                       */
/*****************************************************************************/
/*****************************************************************************/

/* horizontal sections, without precision, without scale (base 2)            */

#ifndef __STDC__
extern int MFAG_cp2();
extern int MFAG_star_2_n_x();
extern int MFAG_cfg2();
extern int MFAG_mcfg2();
#else /* __STDC__ */
extern int MFAG_cp2(short,double*,double*,int,double*,double*);
extern int MFAG_star_2_n_x(short,double*,double*,double,double,int*,double*);
extern int MFAG_cfg2(short,double*,double*,MFAGt_norm,short,double*,double*,double*);
extern int MFAG_mcfg2(short,double*,double*,MFAGt_norm,short,double*,double*,double*);
#endif /* __STDC__ */

/* with horizontal sections, with precision, without scale (base 2)          */

#ifndef __STDC__
extern int MFAG_2_m_x_epsilon();
extern int MFAG_2_m_x_interpol();
extern int MFAG_2_m_x_lr();
extern int MFAG_fgc_2_n_epsilon();
#else /* __STDC__ */
extern int MFAG_2_m_x_epsilon(short,double*,double*,double,double,int*,double*);
extern int MFAG_2_m_x_interpol(short,double*,double*,double,int*,double*);
extern int MFAG_2_m_x_lr(short,double*,double*,double,double,double*,double*,int*);
extern int MFAG_fgc_2_n_epsilon(short,short,double*,double*,short,double*,double,int,int,int,int,double*,double*,int);
#endif /* __STDC__ */

/* with horizontal sections, without precision, without scale (any base)     */

#ifndef __STDC__
extern int MFAG_cpn();
extern int MFAG_cfgn();
extern int MFAG_mcfgn();
#else /* __STDC__ */
extern int MFAG_cpn(int,double*,double*,int,double*,double*);
extern int MFAG_cfgn(int,double*,double*,MFAGt_norm,short,double*,double*,double*);
extern int MFAG_mcfgn(int,double*,double*,MFAGt_norm,short,double*,double*,double*);
#endif /* __STDC__ */

/* with horizontal sections, with scale, without precision                   */

#ifndef __STDC__
extern int MFAG_cp();
extern int MFAG_cfg();
extern int MFAG_mcfg();
#else /* __STDC__ */
extern int MFAG_cp(double,int,double*,double*,int,double*,double*);
extern int MFAG_cfg(short,double*,int,double*,double*,MFAGt_norm,short,double*,double*,double*);
extern int MFAG_mcfg(int,double*,double*,MFAMt_prog,MFAMt_ball,short,double,double,int,double*,double*,double*,MFAGt_norm,short,double*,double*,double*);
#endif /* __STDC__ */

/* with horizontal sections, with scale, with precision, with/without kernel */

#ifndef __STDC__
extern int MFAG_kcpe();
extern int MFAG_kcfge();
extern int MFAG_mkcfge();
extern int MFAG_fkcfge();
#else /* __STDC__ */
extern int MFAG_kcpe(double,int,double*,double*,double(*)(double),short,double*,double*,double*);
extern int MFAG_kcfge(short,double*,int,double*,double*,MFAGt_adap,MFAMt_kern,MFAGt_norm,short,double*,double*,double*,double*,double*);
extern int MFAG_mkcfge(int,double*,double*,MFAMt_ball,MFAMt_prog,short,double,double,int,double*,double*,double*,MFAGt_adap,MFAMt_kern,MFAGt_norm,short,double*,double*,double*,double*,double*);
extern int MFAG_fkcfge(int,double*,double*,MFAMt_prog,MFAMt_osc,double,double,double,short,double*,double*,short,double*,MFAGt_adap,MFAMt_kern,MFAGt_norm,double*,double*,double*,double*);
#endif /* __STDC__ */

/*****************************************************************************/
/*****************************************************************************/
/* vertical sections                                                         */
/*****************************************************************************/
/*****************************************************************************/

/* with vertical sections, with scale, with precision, without kernel        */

#ifndef __STDC__
extern double MFAG_g_eta_epsilon_x_y();
extern int MFAG_vpc_eta_epsilon_y();
extern int MFAG_vcfge();
extern int MFAG_mvcfge();
#else /* __STDC__ */
extern double MFAG_g_eta_epsilon_x_y(int,double,double*,int,double,double,double);
extern int MFAG_vpc_eta_epsilon_y(int,double,double*,double,short,double,double*,double*);
extern int MFAG_vcfge(int,double,double*,double,MFAGt_norm,short,double*,double*,double*,double*);
extern int MFAG_mvcfge(int,double*,double*,int,double,int,MFAGt_norm,short,double*,double*,double*,double*);
#endif /* __STDC__ */

/* with vertical sections, with scale, with precision, with kernel           */

#ifndef __STDC__
extern double MFAG_kg_eta_epsilon_x_alpha();
extern int MFAG_vkcpe();
extern int MFAG_mvkcfge();
#else /* __STDC__ */
extern double MFAG_kg_eta_epsilon_x_alpha(int,double,double*,int,double,double,double(*)(double),double);
extern int MFAG_vkcpe(int,double,double*,double,double(*)(double),int,double,double*,double*);
extern int MFAG_mvkcfge(int,double*,double*,int,double,MFAMt_kern,MFAGt_norm,short,double*,double*,double*,double*);
#endif /* __STDC__ */

/*****************************************************************************/

#ifndef __STDC__
extern int MFAG_cfg1d();
#else /* __STDC__ */
extern int MFAG_cfg1d(short,double*,int,double*,double*,short,double*,MFAGt_cont,MFAGt_adap,MFAMt_kern,MFAGt_norm,double*,double*,double*,double*);
#endif /* __STDC__ */

#ifndef __STDC__
extern int MFAG_mcfg1d();
#else /* __STDC__ */
extern int MFAG_mcfg1d(int,double*,double*,double,double,short,MFAMt_prog,MFAMt_ball,double*,int,double*,double*,short,double*,MFAGt_cont,MFAGt_adap,MFAMt_kern,MFAGt_norm,double*,double*,double*,double*);
#endif /* __STDC__ */

#ifndef __STDC__
extern int MFAG_fcfg1d();
#else /* __STDC__ */
extern int MFAG_fcfg1d(int,double*,double*,MFAMt_prog,MFAMt_osc,double,double,double,short,double*,double*,short,double*,MFAGt_cont,MFAGt_adap,MFAMt_kern,MFAGt_norm,double*,double*,double*,double*);
#endif /* __STDC__ */

#endif /*_MFAG_continuous1d_h_*/
