/*-----------------------------------------------------------------------------
*                                                                              
*                                    FracLab
*                                                                              
*------------------------------------------------------------------------------
*                                                                              
* File path        : /home/users/canus/MFA.CMP/MFAG.CL/src/MFAG_continuous2d.c
* File type        : C source file
* Revision         : $Revision: 1.2 $
* RCS status       : $Id: MFAG_continuous2d.c,v 1.2 1999/02/15 10:34:01 guiheneu Exp $
* Created by       : (Fractales Project INRIA) Christophe Canus
* Creation date    : Sun Feb  7 16:43:28 1999
* Last edited by   : (Fractales Project INRIA) Christophe Canus
* Last edition date: Sun Sep 15 18:10:17 2002
*                                                                              
*------------------------------------------------------------------------------
*                                                                              
* Description : 
*                
*                
*                
*------------------------------------------------------------------------------
*/

/* Christophe Canus 1996-98-02 */

#include "MFAG_continuous2d.h"

/******************/
int MFAG_2_n_xy(short n,int mu_nx_nb,int mu_ny_nb,double *mu_n,double *alpha_n,double beta,double epsilon,int *xy_nb,double *x,double *y)
{
  if((mu_nx_nb>0)&&(mu_ny_nb>0)&&(mu_n!=NULL)&&(alpha_n!=NULL)&&(beta>0.)&&(epsilon>=0.)&&(xy_nb!=NULL)&&(x!=NULL)&&(y!=NULL))
    {
      register int k=0,l=0,i=0,j=0;
      
#ifdef DEBUG
      fprintf(stderr,"beta=%f\n",beta); 
#endif /* DEBUG */

      for(k=0;k<mu_nx_nb;k++)
	{  
	  for(l=0;l<mu_ny_nb;l++)
	    { 
#ifdef DEBUG 
	      fprintf(stderr,"alpha_n^(k=%d,l=%d)=%f\n",k,l,*(alpha_n+k*mu_ny_nb+l));
#endif /* DEBUG */

	      if(fabs(*(alpha_n+k*mu_ny_nb+l)-beta)<epsilon)
		{ 
		  *(x+i)=(double)k/(double)(mu_nx_nb); 
		  *(y+j)=(double)l/(double)(mu_ny_nb);
#ifdef DEBUG
		  fprintf(stderr,"case equal: ");
		  fprintf(stderr,"alpha_n^(k=%d,l=%d)=%f,",k,l,*(alpha_n+k*mu_ny_nb+l));
		  fprintf(stderr,"beta=%f\n",beta);
		  fprintf(stderr,"x(i=%d)=%f\n",i,*(x+i));   
		  fprintf(stderr,"y(j=%d)=%f\n",j,*(y+j));     
#endif /* DEBUG */  

		  i++;
		  j++;
		} 
	      else if((fabs(*(alpha_n+k*mu_ny_nb+l+1)-beta)<epsilon)
		      ||
		      (fabs(*(alpha_n+(k+1)*mu_ny_nb+l)-beta)<epsilon)
		      || 
		      (fabs(*(alpha_n+(k+1)*mu_ny_nb+(l+1))-beta)<epsilon))
		  ;
	      else if(
		      (((*(alpha_n+k*mu_ny_nb+l)<beta)&&(*(alpha_n+k*mu_ny_nb+l+1)>beta))
		       &&
		       ((*(alpha_n+k*mu_ny_nb+l)<beta)&&(*(alpha_n+(k+1)*mu_ny_nb+l)>beta))
		       && 
		       ((*(alpha_n+k*mu_ny_nb+l)<beta)&&(*(alpha_n+(k+1)*mu_ny_nb+l+1)>beta)))		     
		      ||
		      (((*(alpha_n+k*mu_ny_nb+l)>beta)&&(*(alpha_n+k*mu_ny_nb+l+1)<beta))
		       &&
		       ((*(alpha_n+k*mu_ny_nb+l)>beta)&&(*(alpha_n+(k+1)*mu_ny_nb+l)<beta))
		       && 
		       ((*(alpha_n+k*mu_ny_nb+l)>beta)&&(*(alpha_n+(k+1)*mu_ny_nb+l+1)<beta)))
		      )
		{ 
		  *(x+i)=(k*mu_ny_nb+l+(pow(2.,-(double)n*beta)-*(mu_n+k*mu_ny_nb+l))/(*(mu_n+(k+1)*mu_ny_nb+l)-*(mu_n+k*mu_ny_nb+l)))/mu_nx_nb;
		  *(y+i)=(k*mu_ny_nb+l+(pow(2.,-(double)n*beta)-*(mu_n+k*mu_ny_nb+l))/(*(mu_n+k*mu_ny_nb+l+1)-*(mu_n+k*mu_ny_nb+l)))/mu_nx_nb;
	  
#ifdef DEBUG
		  fprintf(stderr,"case non equal: ");
		  fprintf(stderr,"alpha_n^(k=%d,l=%d)=%f\t\t",k,l,*(alpha_n+k*mu_ny_nb+l));
		  fprintf(stderr,"alpha_n^(k+1=%d,l=%d)=%f\n",k+1,l,*(alpha_n+(k+1)*mu_ny_nb+l));
		  fprintf(stderr,"\tbeta=%f\n",beta); 	
		  fprintf(stderr,"alpha_n^(k=%d,l+1=%d)=%f\t\t",k+1,l+1,*(alpha_n+k*mu_ny_nb+l+1)); 
		  fprintf(stderr,"alpha_n^(k+1=%d,l+1=%d)=%f\n",k+1,l+1,*(alpha_n+(k+1)*mu_ny_nb+l+1)); 
		  fprintf(stderr,"x(i=%d)=%f\n",i,*(x+i)); 
		  fprintf(stderr,"y(j=%d)=%f\n",j,*(y+j)); 
#endif /* DEBUG */  

		  i++;
		  j++;
		}
	    }
	}
      *xy_nb=i;

#ifdef DEBUG
      fprintf(stderr,"N(%f)=%d\n",beta,*xy_nb);
      for(k=0;k<*xy_nb;k++)
	{
	  fprintf(stderr,"x(%d)=%f\n",k,*(x+k));
	  fprintf(stderr,"y(%d)=%f\n",k,*(y+k));
	}
#endif /* DEBUG */

      if(*xy_nb<mu_nx_nb)
	if(
	   ((x=(double*)realloc((char*)x,(unsigned)(*xy_nb*sizeof(double))))==NULL)||
	   ((y=(double*)realloc((char*)y,(unsigned)(*xy_nb*sizeof(double))))==NULL)
	   )
	  { 
	    fprintf(stderr,"realloc error\n");
	    return 0;   
	  } 
      return 1;
    }
  else
    {
      fprintf(stderr,"MFAG_2_n_xy arguments error\n");
      return 0;
    }
}
double MFAG_pc_2_n_alpha_2d(short,int,double*,double*);

/******************/
double MFAG_pc_2_n_alpha_2d(short n,int xy_nb,double *x,double *y)
{
  if((n>0)&&(xy_nb>0)&&(x!=NULL))
    { 
      register int k=0;
      double two_pow_minus_n=pow(2.,-(double)n),pc_2_n_alpha=two_pow_minus_n*two_pow_minus_n,d_x=0.,d_y=0.;
      for(k=0;k<xy_nb-1;k++)
	{
	  d_x=*(x+k+1)-*(x+k);
	  d_y=*(y+k+1)-*(y+k);
	  pc_2_n_alpha+=(two_pow_minus_n*two_pow_minus_n>d_x*d_y?d_x*d_y:two_pow_minus_n*two_pow_minus_n);
	} 
      return pc_2_n_alpha;
    }
  else
    {
      fprintf(stderr,"MFAG_pc_2_n_alpha_2d arguments error\n");
      return 0.;
    }
}


/******************/
int MFAG_fgc_2_n_alpha_2d(short n,double *mu_n,double *alpha_n,short beta_n_nb,double *beta_n,double epsilon_n,int Hflg,int Sflg,double *pc_2_n_alpha,double *S_n_alpha)
{
  if((n>0)&&(mu_n!=NULL)&&(alpha_n!=NULL)&&(beta_n_nb>0)&&(beta_n!=NULL)&&(epsilon_n>=0.)&&(pc_2_n_alpha!=NULL)&&(S_n_alpha!=NULL))
    {
      register int k=0;
      int xy_nb=0;
      int two_pow_n=(int)floor(pow(2.,(double)n));
      double *x=NULL,*y=NULL,sup_pc_2_n_alpha=0.,sup_S_n_alpha=0.; 
      for(k=0;k<beta_n_nb;k++) 
	{  
	  if((x=(double*)malloc((unsigned)(two_pow_n*sizeof(double))))==NULL)
	    { 
	      fprintf(stderr,"malloc error\n");
	      return 0;   
	    }  
	  if((y=(double*)malloc((unsigned)(two_pow_n*sizeof(double))))==NULL)
	    { 
	      fprintf(stderr,"malloc error\n");
	      return 0;   
	    } 
	  if(MFAG_2_n_xy(n,two_pow_n,two_pow_n,mu_n,alpha_n,*(beta_n+k),epsilon_n,&xy_nb,x,y)==0)
	    { 
	      fprintf(stderr,"MFAG_2_n_xy error\n");
	      return 0;   
	    }
	  if(xy_nb)
	    *(pc_2_n_alpha+k)=MFAG_pc_2_n_alpha_2d(n,xy_nb,x,y); 
	  else
	    *(pc_2_n_alpha+k)=0.; 
	  if(Hflg)
	    sup_pc_2_n_alpha=(sup_pc_2_n_alpha>*(pc_2_n_alpha+k)?sup_pc_2_n_alpha:*(pc_2_n_alpha+k));
	  free((char*)x); 
	  free((char*)y); 
	}
      for(k=0;k<beta_n_nb;k++)
	{
	  if(two_pow_n*(*(pc_2_n_alpha+k))>1.)
	    {
	      if(Hflg)
		*(pc_2_n_alpha+k)/=sup_pc_2_n_alpha; 
	      *(S_n_alpha+k)=log(two_pow_n*(*(pc_2_n_alpha+k)))/((double)n*log(2.));
	      if(Sflg)
		sup_S_n_alpha=(sup_S_n_alpha>*(S_n_alpha+k)?sup_S_n_alpha:*(S_n_alpha+k));
	    }
	  else
	    *(S_n_alpha+k)=0.;
	} 
      if((Sflg)&&(sup_S_n_alpha!=0.))
	for(k=0;k<beta_n_nb;k++)
	  *(S_n_alpha+k)/=sup_S_n_alpha;  
      return 1;
    } 
  else 
    {
      fprintf(stderr,"MFAG_fgc_2_n_alpha_2d arguments error\n");
      return 0;
    }
}

/******************/
int MFAG_mcfg_2_2d(int mu_nx_nb,double* mu_n,int beta_n_nb,double* beta_n,int Hflg,int Sflg,double* pc_2_n_alpha,double* S_n_alpha)
{ 
  if((mu_nx_nb>0)&&(mu_n!=NULL)&&(beta_n_nb>0)&&(pc_2_n_alpha!=NULL)&&(S_n_alpha!=NULL))
    {
      register int k=0;
      short n=(short)(log((double)mu_nx_nb)/log(2.));
      int two_pow_n=(int)pow(2.,(double)n);
      double *alpha_n=NULL,alpha_n_min=0.,alpha_n_max=0.,two_epsilon_n,epsilon_n=0.;
      if((alpha_n=(double*)malloc(two_pow_n*two_pow_n*sizeof(double)))==NULL)
	{ 
	  fprintf(stderr,"malloc error\n");
	  return 0; 
	} 	 
      if(MFAG_alpha_2_n2d(n,mu_n,alpha_n)==0) 
	{
	  fprintf(stderr,"MFAG_alpha_n error\n"); 
	  return 0; 
	} 	
      if(MFAM_min_max(two_pow_n*two_pow_n,alpha_n,&alpha_n_min,&alpha_n_max)==0)
	{
	  fprintf(stderr,"MFAM_min_max_n error\n"); 
	  return 0;
	}
      two_epsilon_n=(alpha_n_max-alpha_n_min)/(beta_n_nb-1); 
      for(k=0;k<beta_n_nb;k++)
	*(beta_n+k)=alpha_n_min+k*two_epsilon_n; 
      if(beta_n_nb>n+1)
	epsilon_n=0.;
      else 
	epsilon_n=two_epsilon_n/2; 
      if(MFAG_fgc_2_n_alpha_2d(n,mu_n,alpha_n,beta_n_nb,beta_n,epsilon_n,Hflg,Sflg,pc_2_n_alpha,S_n_alpha)==0)
	{
	  fprintf(stderr,"MFAG_fgc_2_n_alpha_2d error\n");
	  return 0;
	}   
      return 1;
    }
  else 
    {
      fprintf(stderr,"MFAG_mcfg_2_2d arguments error\n");
      return 0;
    }
}

/*****************************************************************************/
/* with horizontal sections, without precison, with size, without kernel (2d)*/
/*****************************************************************************/

#ifndef __STDC__
int MFAG_cp2d(eta, Nx, Ny, x, y, alpha_eta_xy, N, alpha, pc_eta_alpha)
     double eta;
     int Nx;
     int Ny;
     double* x; 
     double* y;
     double* alpha_eta_xy;
     int N;
     double* alpha;
     double* pc_eta_alpha;
#else /* __STDC__ */
int MFAG_cp2d(double eta,int Nx,int Ny,double* x,double* y,double* alpha_eta_xy,int N,double* alpha,double* pc_eta_alpha)
#endif /* __STDC__ */
{
  if((eta>0.)&&(Nx>0)&&(Ny>0)&&(alpha_eta_xy!=NULL)&&(N>0)&&(alpha!=NULL)&&(pc_eta_alpha!=NULL))
    { 
      register int nx=0,ny=0,n=0,l=0;
      double s=0.,dx=0.,dy=0.;
      static double x_l[2]={0.,0.};
      if((x==NULL)&&(y==NULL))
	{
	  dx=(1.-eta)/(Nx-1);
	  dy=(1.-eta)/(Ny-1);
	}
      for(n=0;n<N;n++)
	{   
	  for(ny=0;ny<Ny-1;ny++) 
	    {
	      *(pc_eta_alpha+n)=eta*eta; 
	      l=0;
	      for(nx=0;nx<Nx-1;nx++)
		{
		  if((*(alpha_eta_xy+Nx*ny+nx)!=HUGE)&&
		     (((*(alpha_eta_xy+Nx*ny+nx)<=*(alpha+n))&&(*(alpha+n)<*(alpha_eta_xy+Nx*ny+nx+1)))
		      ||
		      ((*(alpha_eta_xy+Nx*ny+nx)>=*(alpha+n))&&(*(alpha+n)>*(alpha_eta_xy+Nx*ny+nx+1)))))
		    {
		      if(x==NULL)
			x_l[1]=nx*dx;
		      else
			{
			  x_l[1]=*(x+Nx*ny+nx);
			  dx=*(x+Nx*ny+nx+1)-*(x+Nx*ny+nx);
			} 
#ifdef LINEAR
		      if((s=(*(alpha_eta_xy+Nx*ny+nx+1)-*(alpha_eta_xy+Nx*ny+nx))/dx)!=0.)
			x_l[1]+=(*(alpha+n)-*(alpha_eta_xy+Nx*ny+nx))/s;
#else /* LINEAR */
		      if((s=(pow(eta,*(alpha_eta_xy+Nx*ny+nx+1))-pow(eta,*(alpha_eta_xy+Nx*ny+nx)))/dx)!=0.)
			x_l[1]+=(pow(eta,*(alpha+n))-pow(eta,*(alpha_eta_xy+Nx*ny+nx)))/s;
#endif /* LINEAR */
		      l++;
		      if(l>1)
			*(pc_eta_alpha+n)+=(eta>x_l[1]-x_l[0]?x_l[1]-x_l[0]:eta)*dy; 
		      x_l[0]=x_l[1];
		    } 
		}
	    }     
	}  
      return 1;
    }
  else
    {
      fprintf(stderr,"MFAG_cp2d arguments error\n");
      return 0;
    }
}

/*****************************************************************************/
/* with horizontal sections, with precision, with size, with/without kernel  */
/*****************************************************************************/

#ifndef __STDC__
int MFAG_kcpe2d(eta, Nx, Ny, x, y, alpha_eta_xy, kern, N, epsilon, alpha, pc2d_eta_epsilon_alpha)
     double eta;
     int Nx; 
     int Ny;
     double* x;
     double* y;
     double* alpha_eta_xy;
     double (*kern)();
     short int N;
     double* epsilon;
     double* alpha;
     double* pc2d_eta_epsilon_alpha;
#else /* __STDC__ */
int MFAG_kcpe2d(double eta,int Nx,int Ny,double* x,double* y,double* alpha_eta_xy,double (*kern)(double),short N,double* epsilon,double* alpha,double* pc2d_eta_epsilon_alpha)
#endif /* __STDC__ */
{
  if((eta>0.)&&(Nx>0)&&(Ny>0)&&(alpha_eta_xy!=NULL)&&(N>0)&&(epsilon!=NULL)&&(alpha!=NULL)&&(pc2d_eta_epsilon_alpha!=NULL))
    {
      register int n=0,k=0;
      double beta_min=*alpha,dbeta=(*(alpha+N-1)-*alpha)/(double)(N-1);
      double* pc_eta_beta=NULL;
      if((pc_eta_beta=(double*)malloc((unsigned)(N*sizeof(double))))==NULL)
	{ 
	  fprintf(stderr,"malloc error\n");
	  return 0;   
	}    
      memset(pc_eta_beta,0.,N*sizeof(double));
      if(MFAG_cp2d(eta,Nx,Ny,x,y,alpha_eta_xy,N,alpha,pc_eta_beta)==0)
	{ 
	  fprintf(stderr,"MFAG_cp2d error\n");
	  return 0;   
	}
      for(n=0;n<N;n++)
	{
	  *(pc2d_eta_epsilon_alpha+n)=0.;
	  for(k=0;k<N;k++) 
	    if(kern==NULL)
	      {
		if((*(alpha+n)-*epsilon<beta_min+k*dbeta)&&
		   (beta_min+k*dbeta<*(alpha+n)+*epsilon))   
		  *(pc2d_eta_epsilon_alpha+n)+=
		    pow(eta,-*(alpha+n))*(-log(eta))/
		    (pow(eta,-*epsilon)-pow(eta,*epsilon))*
		    *(pc_eta_beta+k)*pow(eta,(beta_min+n*dbeta))*dbeta;
	      }
	    else
	      *(pc2d_eta_epsilon_alpha+n)+=
		MFAG_ke(kern,*(epsilon+n),*(alpha+n),beta_min+k*dbeta)*
		*(pc_eta_beta+k)*dbeta;    
	}
      free((char*)pc_eta_beta); 
      return 1;
    } 
  else 
    {
      fprintf(stderr,"MFAG_kcpe2d arguments error\n");
      return 0;
    }
}

/*****************************************************************************/
/* Continuous Large Deviation Spectrum on Hoelder exponents (2d)             */
/* with horizontal sections, without precison, with size, without kernel     */
/*****************************************************************************/

#ifndef __STDC__
int MFAG_cfg2d(J, eta, Nx, Ny, x, y, alpha_eta_xy, t_norm, N, alpha, pc2d_eta_alpha, fgc2d_eta_alpha)
     short int J;
     double* eta;
     int Nx; 
     int Ny;
     double* x; 
     double* y;
     double* alpha_eta_xy;
     MFAGt_norm t_norm;
     short int N;
     double* alpha;
     double* pc2d_eta_alpha;
     double* fgc2d_eta_alpha;
#else /* __STDC__ */
int MFAG_cfg2d(short J,double* eta,int Nx,int Ny,double* x,double* y,double* alpha_eta_xy,MFAGt_norm t_norm,short N,double* alpha,double* pc2d_eta_alpha,double* fgc2d_eta_alpha)
#endif /* __STDC__ */
{ 
  if((J>0)&&(eta!=NULL)&&(Nx>0)&&(Ny>0)&&(alpha_eta_xy!=NULL)&&(N>0)&&(pc2d_eta_alpha!=NULL)&&(fgc2d_eta_alpha!=NULL))
    {
      register int j=0;
      if(MFAG_hoelder(Nx*Ny,J,alpha_eta_xy,N,alpha)==0)
	{
	  fprintf(stderr,"MFAG_hoelder error\n"); 
	  return 0;
	} 
      fprintf(stderr,"c_alpha_min=%f,c_alpha_max=%f\n",*alpha,*(alpha+N-1));
      if(MFAG_cp2d(*(eta+j),Nx,Ny,x,y,alpha_eta_xy,N,alpha,pc2d_eta_alpha)==0)
	{ 
	  fprintf(stderr,"MFAG_cp2d error\n");
	  return 0;   
	}
      if(MFAG_norm(t_norm,*(eta+j),N,NULL,pc2d_eta_alpha,fgc2d_eta_alpha,2)==0)
	{
	  fprintf(stderr,"MFAG_norm error\n");
	  return 0;   
	}
      return 1;
    }
  else 
    {
      fprintf(stderr,"MFAG_cfg2d arguments error\n");
      return 0;
    }
}

/*****************************************************************************/
/* Continuous Large Deviation Spectrum on 2d coarse grain Hoelder exponents  */
/* with horizontal sections, with precision, with size, with kernel          */
/*****************************************************************************/

#ifndef __STDC__
int MFAG_kcfge2d(J, eta, Nx, Ny, x, y, alpha_eta_xy, t_adap, t_kern, t_norm, N, epsilon, alpha, pc2d_eta_epsilon_alpha, fgc2d_eta_epsilon_alpha, epsilon_star)
     short int J;
     double* eta;
     int Nx;
     int Ny;
     double* x; 
     double* y;
     double* alpha_eta_xy;
     MFAGt_adap t_adap;
     MFAMt_kern t_kern;
     MFAGt_norm t_norm;
     short int N;
     double* epsilon;
     double* alpha;
     double* pc2d_eta_epsilon_alpha;
     double* fgc2d_eta_epsilon_alpha;
     double* epsilon_star;
#else /* __STDC__ */
int MFAG_kcfge2d(short J,double* eta,int Nx,int Ny,double* x,double* y,double* alpha_eta_xy,MFAGt_adap t_adap,MFAMt_kern t_kern,MFAGt_norm t_norm,short N,double* epsilon,double* alpha,double* pc2d_eta_epsilon_alpha,double* fgc2d_eta_epsilon_alpha,double* epsilon_star)
#endif /* __STDC__ */
{ 
  if((J>0)&&(eta!=NULL)&&(Nx>0)&&(Ny>0)&&(alpha_eta_xy!=NULL)&&(N>0)&&(epsilon!=NULL)&&(pc2d_eta_epsilon_alpha!=NULL)&&(fgc2d_eta_epsilon_alpha!=NULL)&&(epsilon_star!=NULL))
    {
     
      register int j=0;
#ifndef __STDC__
      double (*kern)();
#else /* __STDC__ */
      double (*kern)(double); 
#endif /* __STDC__ */
      switch(t_kern)
	{  
	case MFAM_INTEGRATED:
	  kern=NULL;
	  break;
	case MFAM_BOXCAR:
	  kern=MFAM_boxcar;
	  break; 
	case MFAM_TRIANGLE:
	  kern=MFAM_triangle;
	  break; 
	case MFAM_GAUSSIAN:
	  kern=MFAM_gauss;
	  break;
	case MFAM_MOLLIFIER:
	  kern=MFAM_mol;
	  break; 
	case MFAM_EPANECHNIKOV:
	  kern=MFAM_epa;
	  break; 
	default:
	  kern=NULL;
	  break;
	} 
      if(MFAG_hoelder(Nx*Ny,J,alpha_eta_xy,N,alpha)==0)
	{
	  fprintf(stderr,"MFAG_hoelder error\n"); 
	  return 0;
	}  
      for(j=0;j<J;j++)
	{
	  if(MFAM_iszeros(N,epsilon)==1)
	    {
	      if(MFAG_adaptation(Nx*Ny,alpha_eta_xy+Nx*Ny*j,N,alpha,epsilon_star+N*j,t_adap)==0)
		{
		  fprintf(stderr,"MFAG_adaptation error\n");
		  return 0;
		}  
	      if(MFAG_kcpe2d(*(eta+j),Nx,Ny,x,y,alpha_eta_xy+Nx*Ny*j,kern,N,epsilon_star+N*j,alpha,pc2d_eta_epsilon_alpha+N*j)==0)
		{
		  fprintf(stderr,"MFAG_kcpe2d error\n"); 
		  return 0;
		}
	      if(MFAG_norm(t_norm,*(eta+j),N,epsilon_star,pc2d_eta_epsilon_alpha+N*j,fgc2d_eta_epsilon_alpha+N*j,2)==0)
		{
		  fprintf(stderr,"MFAG_norm error\n");
		  return 0;   
		}
	    }
	  else
	    {
	      if(MFAG_kcpe2d(*(eta+j),Nx,Ny,x,y,alpha_eta_xy+Nx*Ny*j,kern,N,epsilon,alpha,pc2d_eta_epsilon_alpha+N*j)==0)
		{
		  fprintf(stderr,"MFAG_kcpe2d error\n"); 
		  return 0;
		}
	      if(MFAG_norm(t_norm,*(eta+j),N,epsilon,pc2d_eta_epsilon_alpha+N*j,fgc2d_eta_epsilon_alpha+N*j,2)==0)
		{
		  fprintf(stderr,"MFAG_norm error\n");
		  return 0;   
		}
	    }     
	}
      return 1;
    }
  else 
    {
      fprintf(stderr,"MFAG_kcfge2d arguments error\n");
      return 0;
    }
}

/*****************************************************************************/
/* Continuous Large Deviation Spectrum on 2d measures                        */
/* with horizontal sections, without precison, with size, without kernel     */
/*****************************************************************************/

#ifndef __STDC__
int MFAG_mcfg2d2(N_nx, N_ny, I_nx, I_ny, mu_n, nu_n, t_capa,t_prog, t_ball, J, S_min, S_max, Nx, Ny, eta, x, y, alpha_eta_xy, t_norm, N, alpha, pc_eta_alpha, fgc_eta_alpha)
     int N_nx;
     int N_ny;
     double* I_ny;
     double* I_ny;
     double* mu_n;
     double* nu_n;
     MFAMt_capa t_capa;
     MFAMt_prog t_prog;
     MFAMt_ball t_ball;
     short int J;
     double S_min;
     double S_max;
     int Nx;
     int Ny;
     double* eta;
     double* x;
     double* y;
     double* alpha_eta_xy;
     MFAGt_norm t_norm;
     short int N;
     double* alpha;
     double* pc_eta_alpha;
     double* fgc_eta_alpha;
#else /* __STDC__ */
     int MFAG_mcfg2d2(int N_nx,int N_ny,double* I_nx,double* I_ny,double* mu_n,double* nu_n,MFAMt_capa t_capa,MFAMt_prog t_prog,MFAMt_ball t_ball,short J,double S_min,double S_max,int Nx,int Ny,double* eta,double* x,double* y,double* alpha_eta_xy,MFAGt_norm t_norm,short N,double* alpha,double* pc_eta_alpha,double* fgc_eta_alpha)
#endif /* __STDC__ */
{ 
  if((N_nx>0)&&(N_ny>0)&&(mu_n!=NULL)&&(J>0)&&(S_min>=1.)&&(S_max>=S_min)&&(Nx>=N_nx)&&(Ny>=N_ny)&&(alpha_eta_xy!=NULL)&&(N>0)&&(alpha!=NULL)&&(pc_eta_alpha!=NULL)&&(fgc_eta_alpha!=NULL))
    { 
      if(MFAG_mch2d(N_nx,N_ny,I_nx,I_ny,mu_n,nu_n,t_capa,t_prog,t_ball,J,S_min,S_max,Nx,Ny,eta,x,y,alpha_eta_xy)==0)
	{  
	  fprintf(stderr,"MFAG_mch2d function call error\n");  
	  return 0;  
	}
      if(MFAG_cfg2d(J,eta,Nx,Ny,x,y,alpha_eta_xy,t_norm,N,alpha,pc_eta_alpha,fgc_eta_alpha)==0)
	{  
	  fprintf(stderr,"MFAG_cfg2d function call error\n");  
	  return 0;  
	}
      return 1;
    }
  else 
    {
      fprintf(stderr,"MFAG_mcfg2d2 arguments error\n");
      return 0;
    }
}

/*****************************************************************************/
/* Continuous Large Deviation Spectrum on measures                           */
/* with horizontal sections, with precison, with size, with kernel           */
/*****************************************************************************/

#ifndef __STDC__
int MFAG_mkcfge2d(N_nx, N_ny, I_nx, I_ny, mu_n, nu_n,t_capa, t_prog, t_ball, J, S_min, S_max, Nx, Ny, eta, x, y, alpha_eta_xy, t_adap, t_kern, t_norm, N, epsilon, alpha, pc2d_eta_epsilon_alpha, fgc2d_eta_epsilon_alpha, epsilon_star)
     int N_nx;
     int N_ny;
     double* I_nx;
     double* I_ny;
     double* mu_n; 
     double* nu_n;
     MFAMt_capa t_capa; 
     MFAMt_prog t_prog;
     MFAMt_ball t_ball;
     short int J;
     double S_min;
     double S_max;
     int Nx;
     int Ny;
     double* eta;
     double* x;
     double* y;
     double* alpha_eta_xy;
     MFAGt_adap t_adap;
     MFAMt_kern t_kern;
     MFAGt_norm t_norm;
     short int N;
     double* epsilon;
     double* alpha;
     double* pc2d_eta_epsilon_alpha;
     double* fgc2d_eta_epsilon_alpha;
     double* epsilon_star;
#else /* __STDC__ */
     int MFAG_mkcfge2d(int N_nx,int N_ny,double* I_nx,double* I_ny,double* mu_n,double* nu_n,MFAMt_capa t_capa,MFAMt_prog t_prog,MFAMt_ball t_ball,short J,double S_min,double S_max,int Nx,int Ny,double* eta,double* x,double* y,double* alpha_eta_xy,MFAGt_adap t_adap,MFAMt_kern t_kern,MFAGt_norm t_norm,short N,double* epsilon,double* alpha,double* pc2d_eta_epsilon_alpha,double* fgc2d_eta_epsilon_alpha,double* epsilon_star)
#endif /* __STDC__ */
{ 
  if((N_nx>0)&&(N_ny>0)&&(mu_n!=NULL)&&(J>0)&&(S_min>=1.)&&(S_max>=S_min)&&(Nx>=N_nx)&&(Ny>=N_ny)&&(eta!=NULL)&&(alpha_eta_xy!=NULL)&&(N>0)&&(epsilon!=NULL)&&(alpha!=NULL)&&(pc2d_eta_epsilon_alpha!=NULL)&&(fgc2d_eta_epsilon_alpha!=NULL)&&(epsilon_star!=NULL))
    {
      if(MFAG_mch2d(N_nx,N_ny,I_nx,I_ny,mu_n,nu_n,t_capa,t_prog,t_ball,J,S_min,S_max,Nx,Ny,eta,x,y,alpha_eta_xy)==0)
	{  
	  fprintf(stderr,"MFAG_mch2d function call error\n");  
	  return 0;  
	}
      if(MFAG_kcfge2d(J,eta,Nx,Ny,x,y,alpha_eta_xy,t_adap,t_kern,t_norm,N,epsilon,alpha,pc2d_eta_epsilon_alpha,fgc2d_eta_epsilon_alpha,epsilon_star)==0)
	{  
	  fprintf(stderr,"MFAG_kcfge2d function call error\n");  
	  return 0;  
	}
      return 1;
    }
  else 
    {
      fprintf(stderr,"MFAG_mkcfge2d arguments error\n");
      return 0;
    }
}

/*****************************************************************************/
/* Continuous Large Deviation Spectrum on 2d measures                        */
/*****************************************************************************/

#ifndef __STDC__
int MFAG_mcfg2d(N_nx, N_ny, I_nx, I_ny, mu_n2d, nu_n2d, S_min, S_max, J, t_capa, t_prog, t_ball, eta, Nx, Ny,x, y, alpha_eta_xy, N, epsilon, t_cont, t_adap, t_kern, t_norm, alpha, pc2d_alpha, fgc2d_alpha, epsilon_star)
     int N_nx;
     int N_ny;
     double* I_nx;
     double* I_ny;
     double* mu_n2d;
     double* nu_n2d;
     double S_min;
     double S_max;
     short int J;  
     MFAMt_prog t_capa;
     MFAMt_prog t_prog;
     MFAMt_ball t_ball;
     double* eta;
     int Nx;
     int Ny;
     double* x;
     double* y;
     double* alpha_eta_xy;
     short int N;
     double* epsilon;
     MFAGt_cont t_cont;
     MFAGt_adap t_adap;
     MFAMt_kern t_kern;
     MFAGt_norm t_norm;
     double* alpha;
     double* pc2d_alpha;
     double* fgc2d_alpha;
     double* epsilon_star;
#else /* __STDC__ */
int MFAG_mcfg2d(int N_nx,int N_ny,double* I_nx,double* I_ny,double* mu_n2d,double* nu_n2d,double S_min,double S_max,short J,MFAMt_capa t_capa,MFAMt_prog t_prog,MFAMt_ball t_ball,double* eta,int Nx,int Ny,double* x,double* y,double* alpha_eta_xy,short N,double* epsilon,MFAGt_cont t_cont,MFAGt_adap t_adap,MFAMt_kern t_kern,MFAGt_norm t_norm,double* alpha,double* pc2d_alpha,double* fgc2d_alpha,double* epsilon_star)
#endif /* __STDC__ */
{ 
  if((N_nx>0)&&(N_ny>0)&&(mu_n2d!=NULL)&&(J>0)&&(1.<=S_min)&&(S_min<=S_max)&&(S_max<=N_nx)&&(Nx>=N_nx)&&(Ny>=N_ny)&(eta!=NULL)&&(alpha_eta_xy!=NULL)&&(N>0)&&(epsilon!=NULL)&&(alpha!=NULL)&&(pc2d_alpha!=NULL)&&(fgc2d_alpha!=NULL)&&(epsilon_star!=NULL))
    {
      switch(t_cont)
	{
	case MFAG_HORINOKERN:
	  if(MFAG_mcfg2d2(N_nx,N_ny,I_nx,I_ny,mu_n2d,nu_n2d,t_capa,t_prog,t_ball,J,S_min,S_max,Nx,Ny,eta,x,y,alpha_eta_xy,t_norm,N,alpha,pc2d_alpha,fgc2d_alpha)==0)
	    {
	      fprintf(stderr,"MFAG_mcfg2d2 function call error\n");
	      return 0;
	    } 
	  break;
	case MFAG_HORIKERN:
	  if(MFAG_mkcfge2d(N_nx,N_ny,I_nx,I_ny,mu_n2d,nu_n2d,t_capa,t_prog,t_ball,J,S_min,S_max,Nx,Ny,eta,x,y,alpha_eta_xy,t_adap,t_kern,t_norm,N,epsilon,alpha,pc2d_alpha,fgc2d_alpha,epsilon_star)==0)
	    {
	      fprintf(stderr,"MFAG_mkcfge2d function call error\n");
	      return 0;
	    } 
	  break;
	default:
	  fprintf(stderr,"MFAG_mcfg2d arguments error\n"); 
	  return 0; 
	}
      return 1;
    }
  else
    {
      fprintf(stderr,"MFAG_mcfg2d arguments error\n"); 
      fprintf(stderr,"\tN_nx=[7m%d[m\n",N_nx); 
      fprintf(stderr,"\tN_ny=[7m%d[m\n",N_ny);
      fprintf(stderr,"\tI_nx=[7m%p[m\n",I_nx); 
      fprintf(stderr,"\tI_ny=[7m%p[m\n",I_ny);
      fprintf(stderr,"\tmu_n2d=[7m%p[m\n",mu_n2d); 
      fprintf(stderr,"\tnu_n2d=[7m%p[m\n",nu_n2d); 
      fprintf(stderr,"\tS_min=[7m%f[m\n",S_min);     
      fprintf(stderr,"\tS_max=[7m%f[m\n",S_max);   
      return 0;
    }
}
