/*-----------------------------------------------------------------------------
*                                                                              
*                                    FracLab
*                                                                              
*------------------------------------------------------------------------------
*                                                                              
* File path        : /home/canus/MFA.CMP/MFAG.CL/inc/MFAG_misc.h
* File type        : C header file
* Revision         : $Revision: 1.1.1.1 $
* RCS status       : $Id: MFAG_misc.h,v 1.1.1.1 1999/02/10 13:38:44 guiheneu Exp $
* Created by       : (Fractales Project INRIA) Christophe Canus
* Creation date    : Sun Feb  7 16:41:05 1999
* Last edited by   : (Fractales Project INRIA) Christophe Canus
* Last edition date: Sun Feb  7 16:41:06 1999
*                                                                              
*------------------------------------------------------------------------------
*                                                                              
* Description : 
*                
*                
*                
*------------------------------------------------------------------------------
*/

#ifndef _MFAG_misc_h_
#define _MFAG_misc_h_
#include "MFAM_include.h"
#include "MFAM_misc.h"
#include "MFAM_kernel.h"
#include "MFAM_adaption.h"

typedef enum
{
  MFAG_HORI2=0,
  MFAG_HORIANYBASE=1,
  MFAG_HORINOKERN=2,
  MFAG_HORIKERN=3,
  MFAG_VERTNOKERN=4,
  MFAG_VERTKERN=5
} MFAGt_cont;

#define MFAG_HORI2STR "h2"
#define MFAG_HORIANYBASESTR "hany"
#define MFAG_HORINOKERNSTR "hnokern"
#define MFAG_HORIKERNSTR "hkern"
#define MFAG_VERTNOKERNSTR "vnokern"
#define MFAG_VERTKERNSTR "vkern"

#ifndef __STDC__
extern int MFAG_contstr();
#else /* __STDC__ */
extern int MFAG_contstr(char*,MFAGt_cont*);
#endif /* __STDC__ */

#ifndef __STDC__
extern int MFAG_hoelder();
#else /* __STDC__ */
extern int MFAG_hoelder(int,short,double*,int,double*);
#endif /* __STDC__ */

#ifndef __STDC__
extern double MFAG_ke();
#else /* __STDC__ */
extern double MFAG_ke(double(*)(double),double,double,double);
#endif /* __STDC__ */

typedef enum
{ 
  MFAG_MAXDEV=0,
  MFAG_MINDEV=1,
  MFAG_MEANDEV=2,
  MFAG_MEANADAPTDEV=3,
  MFAG_MAXADAPTDEV=4,
  MFAG_ONEMODADAPTDEV=5,
  MFAG_LAP=6,
} MFAGt_adap;

#define MFAG_MINDEVSTR "mindev"
#define MFAG_MAXDEVSTR "maxdev"
#define MFAG_MEANDEVSTR "meandev"
#define MFAG_MEANADAPTDEVSTR "meanadaptdev"
#define MFAG_MAXADAPTDEVSTR "maxadaptdev"
#define MFAG_ONEMODADAPTDEVSTR "onemodadaptdev"
#define MFAG_LAPSTR "lap"

#ifndef __STDC__
extern int MFAG_adapstr();
extern int MFAG_adaptation();
#else /* __STDC__ */
extern int MFAG_adapstr(char*,MFAGt_adap*);
extern int MFAG_adaptation(int,double*,int,double*,double*,MFAGt_adap);
#endif /* __STDC__ */

typedef enum
{ 
  MFAG_NONORM=0,
  MFAG_SUPPDF=1,
  MFAG_SUPFG=2,
  MFAG_INFSUPPDF=3,
  MFAG_INFSUPFG=4
} MFAGt_norm;

#define MFAG_NONORMSTR "nonorm"
#define MFAG_SUPPDFSTR "suppdf"
#define MFAG_SUPFGSTR "supfg"
#define MFAG_INFSUPPDFSTR "infsuppdf"
#define MFAG_INFSUPFGSTR "infsupfg"
 
#ifndef __STDC__
extern int MFAG_normstr();
extern int MFAG_norm();
extern int MFAG_alpha_eta_x_extrema();
#else /* __STDC__ */
extern int MFAG_normstr(char*,MFAGt_norm*);
extern int MFAG_norm(MFAGt_norm,double,short,double*,double*,double*,int);
extern int MFAG_alpha_eta_x_extrema(int,double,double*,double,double,double*,double*);
#endif /* __STDC__ */

#endif /*_MFAG_misc_h_*/
