/*-----------------------------------------------------------------------------
*                                                                              
*                                    FracLab
*                                                                              
*------------------------------------------------------------------------------
*                                                                              
* File path        : /home/canus/MFA.CMP/MFAH.CL/src/MFAH_fdlimsup.c
* File type        : C source file
* Revision         : $Revision: 1.1.1.1 $
* RCS status       : $Id: MFAH_fdlimsup.c,v 1.1.1.1 2000/07/10 10:05:44 raynal Exp $
* Created by       : (Fractales Project INRIA) Christophe Canus
* Creation date    : Sun Feb  7 16:24:43 1999
* Last edited by   : (Fractales Project INRIA) Christophe Canus
* Last edition date: Sun Feb  7 16:24:45 1999
*                                                                              
*------------------------------------------------------------------------------
*                                                                              
* Description : 
*                
*                
*                
*------------------------------------------------------------------------------
*/

#include "MFAH_fdlimsup.h"

int MFAH_fdlimsup(btree *tree,int beta_n_nb,double *beta_n,double epsilon_n,short N_min,short N_max,short N_step,int tflg,int sflg,double *f_alpha)
{
   register int k=0;
   short N=0,n_min=1.,n_max=0.;
   double d=0.,m_d=0.,sup_d=0,sup_f_alpha=0.;
   const double v_e=0.01;
   for(k=0;k<beta_n_nb;k++)      
   {  
      N=N_max; 
      if(tflg)
	 N_min=N_max;
      sup_d=0.;
      m_d=0.;
      while(N>=N_min)  
      {   
	 fprintf(stderr,"btree_isosN with parameters N=%d, h=%e and epsilon_n=%e\n",N,*(beta_n+k),epsilon_n);
	 if(tflg)
	    btree_isosN(tree,N,*(beta_n+k),2*epsilon_n);
	 else
	    btree_isos(tree,N,*(beta_n+k),epsilon_n);
	 n_max=N-2;
	 fprintf(stderr,"box with parameters N=%d, n_min=%d, n_max=%d and v_e=%f\n",N,n_min,n_max,v_e);
	 d=MFAD_box(*(tree->s_level+N),N,n_min,n_max,v_e); 
	 fprintf(stderr,"d(E_%d^%f(%f))=%f\n",N,epsilon_n,*(beta_n+k),d);	
	 sup_d=(sup_d>d?sup_d:d);
	 m_d+=d;

#ifdef MFA  
	 two_pow_N=(int)pow(2.,(double)N);
	 two_pow_N_2=(int)pow(2.,(double)N/2.); 
	 sprintf(sname,spat,*(beta_n+k),epsilon_n,N);
  
	 MfaMEXITERROR(MfaMImageNew(two_pow_N_2,
				    two_pow_N_2,
				    MfaMUINT08,
				    sname,
				    &ptimg));
	 MfaMVECTORDELETE(ptimg->ptData); 
	 MfaMVECTORATTRIB(*(tree->s_level+N),
			  MfaMtChar,ptimg->ptData);  
	 for(n=0;n<two_pow_N;n++)
	    *(ptimg->ptData+n)=255**(ptimg->ptData+n);
	 MfaMIMAGEVISUXV(ptimg,
			 sname);
	 MfaMEXITERROR(MfaMImageDelete(&ptimg));
#endif /* MFA */ 

         btree_s_leveldelete(tree,N);
	 fprintf(stderr,"btree_s_leveldelete with parameter N=%d\n",N);	 
	 N-=N_step;   
      }
      m_d/=((N_max-N_min)/N_step+1); 
    
#ifdef DEBUG 
      fprintf(stderr,"beta_n=%f\n",*(beta_n+k));  
      fprintf(stderr,"d(E_%d^%f(%f))=%f\n",N,epsilon_n,*(beta_n+k),d);
      fprintf(stderr,"sup_N(d)=%f\n",sup_d);
      fprintf(stderr,"m_N(d))=%f\n",m_d);
      getchar();
#endif /* DEBUG */
       
      if(sflg)
	 *(f_alpha+k)=sup_d;
      else
	 *(f_alpha+k)=m_d;
      sup_f_alpha=(sup_f_alpha>*(f_alpha+k)?sup_f_alpha:*(f_alpha+k));
   } 
   return 1;
}
