/*-----------------------------------------------------------------------------
*                                                                              
*                                    FracLab
*                                                                              
*------------------------------------------------------------------------------
*                                                                              
* File path        : /home/users/canus/MFA.CMP/MFAH.CL/src/MFAH_hoelder2d.c
* File type        : C source file
* Revision         : $Revision: 1.1.1.1 $
* RCS status       : $Id: MFAH_hoelder2d.c,v 1.1.1.1 1999/02/10 13:39:49 guiheneu Exp $
* Created by       : (Fractales Project INRIA) Christophe Canus
* Creation date    : Sun Feb  7 16:24:08 1999
* Last edited by   : (Fractales Project INRIA) Christophe Canus
* Last edition date: Mon Sep  2 14:41:19 2002
*                                                                              
*------------------------------------------------------------------------------
*                                                                              
* Description : 
*                
*                
*                
*------------------------------------------------------------------------------
*/

/* Christophe Canus 1998 */

#include "MFAH_hoelder2d.h"

extern double norm_meas;
extern double p;
extern double c_ref;
extern double q;
extern double sigma2;

double i_c_delta;
double norm_mu;
double norm_c;

/*****************************************************************************/

int MFAH_capa2d(int Nx,double* c2d,short J,double* S,double (*capa)(double,double),double* log_c_delta)
{
  if((Nx>0)&&(c2d!=NULL)&&(J>0)&&(S!=NULL)&&(capa!=NULL)&&(log_c_delta!=NULL))
    {
      register int i=0,j=0,k=0;
      int xc=0,yc=0,s=0;
      double c_delta=i_c_delta;
      xc=((int)*(S+J-1)-1)/2;
      yc=((int)*(S+J-1)-1)/2;
      c_ref=*(c2d+Nx*yc+xc);
      xc=((int)(*(S+J-1)-*S+1))/2;
      yc=((int)(*(S+J-1)-*S+1))/2;
      for(j=0;j<(int)*S;j++)
	for(i=0;i<(int)*S;i++)
	  c_delta=capa(c_delta,*(c2d+Nx*(yc+j)+xc+i));
      *log_c_delta=(c_delta!=0.?log(c_delta):0.);
      k++;
      for(s=(int)*S+2;s<=(int)*(S+J-1);s+=2)
	{ 
	  xc=((int)*(S+J-1)-s+1)/2;
	  yc=((int)*(S+J-1)-s+1)/2;
	  for(j=0;j<s;j+=s-1)
	    for(i=0;i<s;i++)
	      c_delta=capa(c_delta,*(c2d+Nx*(yc+j)+xc+i));
	  for(i=0;i<s;i+=s-1)
	    for(j=1;j<s-1;j++)
	      c_delta=capa(c_delta,*(c2d+Nx*(yc+j)+xc+i));
	  if(s==*(S+k))
	    {
	      *(log_c_delta+k)=(c_delta!=0.?log(c_delta):0.);
	      k++;
	    }
	}
      return 1;
    }
  else
    {  
      fprintf(stderr,"MFAH_capa2d arguments error\n");
      fprintf(stderr,"\tNx=[7m%d[m\n",Nx);
      fprintf(stderr,"\tc2d=[7m%p[m\n",c2d);
      fprintf(stderr,"\tJ=[7m%d[m\n",J);
      fprintf(stderr,"\tS=[7m%p[m\n",S);
      fprintf(stderr,"\tcapa=[7m%p[m\n",capa);
      fprintf(stderr,"\tlog_c_delta=[7m%p[m\n",log_c_delta);
      return 0;
    }
}

/*****************************************************************************/

int MFAH_mma2d(int Nx,double* c2d,double* mu2d,short J,double* S,double (*capa)(double,double),double* log_c_delta,double* log_mu_delta)
{
  if((Nx>0)&&(c2d!=NULL)&&(mu2d!=NULL)&&(J>0)&&(S!=NULL)&&(capa!=NULL)&&(log_c_delta!=NULL)&&(log_mu_delta!=NULL))
    {
      register int i=0,j=0,k=0;
      int xc=0,yc=0,s=0;
      double c_delta=i_c_delta,mu_delta=0.;
      xc=((int)*(S+J-1)-1)/2;
      yc=((int)*(S+J-1)-1)/2;
      c_ref=*(c2d+Nx*yc+xc);
      xc=((int)(*(S+J-1)-*S+1))/2;
      yc=((int)(*(S+J-1)-*S+1))/2;
      for(j=0;j<(int)*S;j++)
	for(i=0;i<(int)*S;i++)
	  {
	    norm_meas=norm_mu;
	    mu_delta=MFAM_sum(mu_delta,*(mu2d+Nx*(yc+j)+xc+i)); 
	    norm_meas=norm_c;
	    c_delta=capa(c_delta,*(c2d+Nx*(yc+j)+xc+i));
	  }
      *log_mu_delta=(mu_delta!=0.?log(mu_delta):0.);
      *log_c_delta=(c_delta!=0.?log(c_delta):0.);
      k++;
      for(s=(int)*S+2;s<=(int)*(S+J-1);s+=2)
	{ 
	  xc=((int)*(S+J-1)-s+1)/2;
	  yc=((int)*(S+J-1)-s+1)/2;
	  for(j=0;j<s;j+=s-1)
	    for(i=0;i<s;i++)
	      {
		norm_meas=norm_mu;
		mu_delta=MFAM_sum(mu_delta,*(mu2d+Nx*(yc+j)+xc+i));
		norm_meas=norm_c;
		c_delta=capa(c_delta,*(c2d+Nx*(yc+j)+xc+i));
	      }
	  for(i=0;i<s;i+=s-1)
	    for(j=1;j<s-1;j++)
	      {
		norm_meas=norm_mu;
		mu_delta=MFAM_sum(mu_delta,*(mu2d+Nx*(yc+j)+xc+i)); 
		norm_meas=norm_c;
		c_delta=capa(c_delta,*(c2d+Nx*(yc+j)+xc+i));
	      }
	  if(s==*(S+k))
	    {
	      if(capa==MFAM_sum)
		{
		  *log_mu_delta=(mu_delta!=0.?log(mu_delta):0.);
		  *log_c_delta=(c_delta!=0.?log(c_delta):0.);
		}
	      else
		{
		  *(log_mu_delta+k)=(mu_delta!=0.?log(mu_delta):0.);
		  *(log_c_delta+k)=(c_delta!=0.?log(c_delta):0.);
		}
	      k++;
	    }
	}
      return 1;
    }
  else
    {  
      fprintf(stderr,"MFAH_mma2d arguments error\n");  
      fprintf(stderr,"\tNx=[7m%d[m\n",Nx);
      fprintf(stderr,"\tc2d=[7m%p[m\n",c2d); 
      fprintf(stderr,"\tmu2d=[7m%p[m\n",mu2d);
      fprintf(stderr,"\tJ=[7m%d[m\n",J);
      fprintf(stderr,"\tS=[7m%p[m\n",S);
      fprintf(stderr,"\tcapa=[7m%p[m\n",capa);
      fprintf(stderr,"\tlog_c_delta=[7m%p[m\n",log_c_delta); 
      fprintf(stderr,"\tlog_mu_delta=[7m%p[m\n",log_mu_delta);
      return 0;
    }
}

/*****************************************************************************/

int MFAH_mph2d(int Nx,int Ny,double* c2d,double* mu2d,int J,double* S,MFAMt_capa t_capa,double P,short Q,double* p_alpha2d)
{ 
  if((Nx>0)&&(Ny>0)&&(c2d!=NULL)&&(J>0)&&(S!=NULL)&&(P>1.)&&(Q>0)&&(p_alpha2d!=NULL))
    {
      register int x=0,y=0;
      int Nx_f=Nx-(int)*(S+J-1)+1,Ny_f=Ny-(int)*(S+J-1)+1;
      double p_alpha=0.;
      double* log_c_delta=NULL;
      double* log_mu_delta=NULL;
      double (*capa)(double,double);
      switch(t_capa)
	{
	case MFAM_SUM:
	  i_c_delta=0.;
	  norm_c=0.;
	  for(x=0;x<Nx*Ny;x++) 
	    norm_c+=*(c2d+x);
	  capa=MFAM_sum;
	  break;
	case MFAM_LPSUM:
	  i_c_delta=0.;
	  norm_c=0.;
	  for(x=0;x<Nx*Ny;x++) 
	    norm_c+=*(c2d+x);
	  p=P;
	  capa=MFAM_lpsum;
	  break; 
	case MFAM_MIN:
	  i_c_delta=HUGE;
	  capa=MFAM_min;
	  break; 
	case MFAM_MAX:
	  i_c_delta=-HUGE;
	  capa=MFAM_max;
	  break;
	case MFAM_ISO:
	  {
	    double c2d_min=0.,c2d_max=-HUGE;
	    i_c_delta=0.;
	    if(MFAM_min_max(Nx*Ny,c2d,&c2d_min,&c2d_max)==0)
	      { 
		fprintf(stderr,"MFAM_min_max function call error\n"); 
		return 0; 
	      }
	    q=(c2d_max-c2d_min)/Q;
	    capa=MFAM_iso;
	    break;
	  }
	case MFAM_ADAPISO:
	  i_c_delta=0.;
	  if((sigma2=MFAM_variance(Nx*Ny,c2d,MFAM_mean(Nx*Ny,c2d)))==HUGE)
	    {
	      fprintf(stderr,"MFAM_variance function call error\n"); 
	      return 0; 
	    }
	  capa=MFAM_adapiso;
	  break; 
	default:
	  return 0;
	} 
      if((log_mu_delta=(double*)malloc((unsigned int)(J*sizeof(double))))==0)
	{
	  fprintf(stderr,"malloc error\n");
	  return 0;
	}
      memset(log_mu_delta,0,J*sizeof(double));

      if((log_c_delta=(double*)malloc((unsigned int)(J*sizeof(double))))==0)
	{
	  fprintf(stderr,"malloc error\n");
	  return 0;
	}
      memset(log_c_delta,0,J*sizeof(double));

      if(mu2d==NULL)
	{
	  for(x=0;x<J;x++) 
	    {
	      if(*(S+x)<=0)
		*(log_mu_delta+x)=0;
	      else
		*(log_mu_delta+x)=log(*(S+x));
	    }
	  norm_meas=norm_c;
	}
      else
	{
	  norm_mu=0.;
	  for(x=0;x<Nx*Ny;x++) 
	    norm_mu+=*(mu2d+x);
	}
      for(y=0;y<Ny_f;y++) 
	{
	  for(x=0;x<Nx_f;x++)
	    { 
	      p_alpha=0;
	      if(mu2d==NULL)
		{
		  if(MFAH_capa2d(Nx,c2d+Nx*y+x,J,S,capa,log_c_delta)==0)
		    {
		      fprintf(stderr,"MFAH_capa2d function call error\n");
		      return 0;
		    }
		}
	      else
		{ 
		  if(MFAH_mma2d(Nx,c2d+Nx*y+x,mu2d+Nx*y+x,J,S,capa,log_c_delta,log_mu_delta)==0)
		    {
		      fprintf(stderr,"MFAH_mma2d function call error\n");
		      return 0;
		    }
		}
	      if(J>1)
		{
		  double b=0.,sigma2_e=0.;
		  if(MFAM_lslr(J,log_mu_delta,log_c_delta,&p_alpha,&b,NULL,NULL,&sigma2_e)==0)
		    {
		      fprintf(stderr,"MFAM_lslr function call error\n");
		      return 0;
		    }
		}                       
	      else /* J==1 */               
		{
		  if(*log_c_delta<0.)
		    {
		      if(mu2d==NULL)
			*log_mu_delta=log((double)(Nx*Ny))/-2.;
		    }
		  else /* *log_c_delta>=0. */
		    {
		      if(*S!=1) 
			{
			  if(*S<=0) 
			    *log_mu_delta=0;
			  else
			    *log_mu_delta=log(*S);
			}
		      else
			*log_mu_delta=1.; 
		    }
		  if (*log_mu_delta==0) 
		    *log_mu_delta = 0.00001;
		  p_alpha=*log_c_delta/(*log_mu_delta);
		}
	      *(p_alpha2d+Nx*(y+((int)*(S+J-1)-1)/2)+x+((int)*(S+J-1)-1)/2)=(((t_capa==MFAM_MIN)||(t_capa==MFAM_MAX))?fabs(p_alpha):p_alpha);
	    } 
	}  
      free((char*)log_mu_delta);
      free((char*)log_c_delta);
      return 1;
    }
  else
    {
      fprintf(stderr,"MFAH_mph2d arguments error\n"); 
      fprintf(stderr,"\tNx=[7m%d[m\n",Nx); 
      fprintf(stderr,"\tNy=[7m%d[m\n",Ny);
      fprintf(stderr,"\tc2d=[7m%p[m\n",c2d); 
      fprintf(stderr,"\tJ=[7m%d[m\n",J);
      fprintf(stderr,"\tS=[7m%p[m\n",S); 
      fprintf(stderr,"\tt_capa=[7m%d[m\n",t_capa);
      fprintf(stderr,"\tP=[7m%f[m\n",P);  
      fprintf(stderr,"\tQ=[7m%d[m\n",Q);
      fprintf(stderr,"\tp_alpha2d=[7m%p[m\n",p_alpha2d);
      return 0;
    }
} 
