/*-----------------------------------------------------------------------------
*                                                                              
*                                    FracLab
*                                                                              
*------------------------------------------------------------------------------
*                                                                              
* File path        : /home/users/canus/MFA.CMP/MFAL.CL/src/MFAL_partition.c
* File type        : C source file
* Revision         : $Revision: 1.2 $
* RCS status       : $Id: MFAL_partition.c,v 1.2 1999/03/01 09:23:35 canus Exp $
* Created by       : (Fractales Project INRIA) Christophe Canus
* Creation date    : Sun Feb  7 18:47:49 1999
* Last edited by   : (Fractales Project INRIA) Christophe Canus
* Last edition date: Tue Aug 20 21:34:54 2002
*                                                                              
*------------------------------------------------------------------------------
*                                                                              
* Description : 
*                
*                
*                
*------------------------------------------------------------------------------
*/

#include "MFAL_partition.h"

/*****************************************************************************/
 
#ifndef __STDC__
int MFAL_mdZSq1d(N_n, mu_n, J, S, Q, q, Z_S_q)
     int N_n;
     double* mu_n;
     short int J;
     double* S;
     short int Q;
     double* q;
     double* Z_S_q;
#else /* __STDC__ */
     int MFAL_mdZSq1d(int N_n,double* mu_n,short J,double* S,short Q,double* q,double* Z_S_q)
#endif /* __STDC__ */
{
  if((N_n>0)&&(mu_n!=NULL)&&(J>0)&&(S!=NULL)&&(Q>0)&&(q!=NULL)&&(Z_S_q!=NULL))
    {
      register int j=0,k=0,l=0;
      double mu_S1d=0.;
      for(j=0;j<J;j++)
	{
	  for(k=0;k<Q;k++)
	    {
	      *(Z_S_q+Q*j+k)=0.;
	      for(l=0;l<N_n;l+=(int)*(S+j))
		{
		  mu_S1d=MFAM_mu_S1d(mu_n+l,(int)*(S+j));
		  *(Z_S_q+Q*j+k)+=(mu_S1d!=0.?pow(mu_S1d,*(q+k)):0);
		}
	    }
	}
      return 1;
    }
  else
    {
      fprintf(stderr,"MFAL_mdZSq1d arguments error\n");
      return 0;
    }
}

/*****************************************************************************/
 
#ifndef __STDC__
int MFAL_mdZPq1d(N_n, mu_n, J, P, Q, q, Z_P_q)
     int N_n;
     double* mu_n;
     short int J;
     double* P;
     short int Q;
     double* q;
     double* Z_P_q;
#else /* __STDC__ */
     int MFAL_mdZPq1d(int N_n,double* mu_n,short J,double* P,short Q,double* q,double* Z_P_q)
#endif /* __STDC__ */
{
  if((N_n>0)&&(mu_n!=NULL)&&(J>0)&&(P!=NULL)&&(Q>0)&&(q!=NULL)&&(Z_P_q!=NULL))
    {
      register int k=0,j=0,l=0;  
      double mu_P1d=0.;
      for(j=0;j<J;j++)
	{
	  for(k=0;k<Q;k++)
	    {
	      *(Z_P_q+Q*j+k)=0.;
	      for(l=0;l<(int)*(P+j);l++)
		{
		  FRflg=(l==0);
		  mu_P1d=MFAM_mu_P1d(N_n,mu_n,(int)*(P+j));
		  *(Z_P_q+Q*j+k)+=(mu_P1d!=0.?pow(mu_P1d,*(q+k)):0);
		}
	    }
	}
      return 1;
    }
  else
    {
      fprintf(stderr,"MFAL_mdZPq1d arguments error\n");
      return 0;
    }
}

/*****************************************************************************/

int MFAL_fcZetaq1d(int M,double* x,double* f_x,MFAMt_osc t_osc,double p,short J,double* eta,short Q,double* q,double* Z_eta_q)
{
  if((M>0)&&(f_x!=NULL)&&(J>0)&&(p>=1.)&&(eta!=NULL)&&(Q>0)&&(q!=NULL)&&(Z_eta_q!=NULL))
    {
      register int j=0,k=0,l=0;  
      double dx=1./M;
      double* deltax=NULL;
      double* osc_eta_x=NULL;
      if((osc_eta_x=(double*)malloc((unsigned)(M*sizeof(double))))==NULL)
	{
	  fprintf(stderr,"malloc error\n"); 
	  return 0;
	}
      for(j=0;j<J;j++)
	{
	  for(k=0;k<Q;k++)
	    {
	      *(Z_eta_q+Q*j+k)=0.;
	      switch(t_osc)
		{
		case MFAM_OSC:
		  if(MFAM_osc_eta_x(M,dx,f_x,*(eta+j),osc_eta_x)==0)
		    {
		      fprintf(stderr,"MFAM_osc_eta_x error\n"); 
		      return 0;
		    }
		  break;
		case MFAM_OSCDELTA:
		  if((deltax=(double*)malloc((unsigned)(M*sizeof(double))))==NULL)
		    {
		      fprintf(stderr,"malloc error\n"); 
		      return 0;
		    }
		  if(MFAM_osc_eta_deltax(M,dx,f_x,*(eta+j),deltax,osc_eta_x)==0)
		    {
		      fprintf(stderr,"MFAM_osc_eta_deltax error\n"); 
		      return 0;
		    }
		  break;
		case MFAM_LINFTY:
		  if(MFAM_Linfty_eta_x(M,dx,f_x,*(eta+j),osc_eta_x)==0)
		    {
		      fprintf(stderr,"MFAM_Linfty_eta_x error\n"); 
		      return 0;
		    }
		  break;
		case MFAM_LP:
		  if(MFAM_Lp_eta_x(M,dx,f_x,p,*(eta+j),osc_eta_x)==0)
		    {
		      fprintf(stderr,"MFAM_Lp_eta_x error\n"); 
		      return 0;
		    }
		  break;
		}
	      for(l=0;l<M;l++)
		*(Z_eta_q+Q*j+k)+=(*(osc_eta_x+l)!=0.?pow(*(osc_eta_x+l),*(q+k)):0)*dx;
	      *(Z_eta_q+Q*j+k)/=*(eta+j);
	    }
	} 
      free((char*)osc_eta_x);
      return 1;
    }
  else
    {
      fprintf(stderr,"MFAL_fcZetaq1d arguments error\n");
      return 0;
    }
}

/*****************************************************************************/

#ifndef __STDC__
int MFAL_mdZq1d(N_n, mu_n, t_part, J, S_min, S_max, P_min, P_max, a, Q, q, Z_a_q)
     int N_n;
     double* mu_n;
     MFAMt_part t_part;
     short int J;
     double S_min;
     double S_max;
     double P_min;
     double P_max;
     double* a;
     short int Q;
     double* q;
     double* Z_a_q;
#else /* __STDC__ */
     int MFAL_mdZq1d(int N_n,double* mu_n,MFAMt_part t_part,short J,double S_min,double S_max,double P_min,double P_max,double* a,short Q,double* q,double* Z_a_q)
#endif /* __STDC__ */
{
  if((N_n>0)&&(mu_n!=NULL)&&(J>0)&&(a!=NULL)&&(S_min>=1.)&&(S_min<=S_max)&&(S_max<=N_n/2.)&&(P_min>=1.)&&(P_min<=P_max)&&(P_max<=N_n/2.)&&(Q>0)&&(q!=NULL)&&(Z_a_q!=NULL))
    {
      register int j=0;
      if(t_part==MFAM_DECSIZE)
	{
	  double* S=a;
	  if(MFAM_decsizespace(N_n,J,S_min,S_max,S)==0) 
	    { 
	      fprintf(stderr,"MFAM_decsizespace error\n");  
	      return 0; 
	    }
	  if(MFAL_mdZSq1d(N_n,mu_n,J,S,Q,q,Z_a_q)==0)
	    {
	      fprintf(stderr,"MFAL_mdZSq1d error\n");
	      return 0;
	    } 
	  for(j=0;j<J;j++)
	    *(a+j)=(*(S+j)/S_min);
	  S=NULL;
	}
      else
	{  
	  double* P=a;
	  if(MFAM_partspace(N_n,t_part,J,P_min,P_max,P)==0) 
	    { 
	      fprintf(stderr,"MFAM_partspace error\n");  
	      return 0; 
	    }  
	  if(MFAL_mdZPq1d(N_n,mu_n,J,P,Q,q,Z_a_q)==0)
	    {
	      fprintf(stderr,"MFAL_mdZPq1d error\n");
	      return 0;
	    }
	  for(j=0;j<J;j++)
	    *(a+j)=(P_max/(*(P+j)));
	  P=NULL;
	}
      return 1;
    }
  else
    {
      fprintf(stderr,"MFAL_mdZq1d arguments error\n");
      return 0;
    }
}

/*****************************************************************************/

int MFAL_fcZq1d(int M,double* x,double* f_x,MFAMt_prog t_prog,MFAMt_osc t_osc,double p,short J,double S_min,double S_max,double* a,short Q,double* q,double* Z_a_q)
{
  if((M>0)&&(f_x!=NULL)&&(J>0)&&(p>=1.)&&(S_min>=1.)&&(S_min<=S_max)&&(S_max<=M)&&(a!=NULL)&&(Q>0)&&(q!=NULL)&&(Z_a_q!=NULL))
    {
      register int j=0;
      double* eta=a; 
      if(MFAM_scale(M,S_min,S_max,J,eta,t_prog,1)==0) 
	{ 
	  fprintf(stderr,"MFAM_scale error\n");  
	  return 0; 
	}
      if(MFAL_fcZetaq1d(M,x,f_x,t_osc,p,J,eta,Q,q,Z_a_q)==0)
	{
	  fprintf(stderr,"MFAL_fcZetaq1d error\n");
	  return 0;
	} 
      for(j=0;j<J;j++)
	*(a+j)=(*(eta+j)*M/S_min);
      eta=NULL;
      return 1;
    }
  else
    {
      fprintf(stderr,"MFAL_fcZq1d arguments error\n");
      return 0;
    }
}

/*****************************************************************************/

#ifndef __STDC__
int MFAL_mdZSq2d(Nx_n, Ny_n, mu_n, J, S, Q, q, Z_S_q)
     int Nx_n;
     int Ny_n;
     double* mu_n;
     int J;
     double* S;
     int Q;
     double* q;
     double* Z_S_q;
#else /* __STDC__ */
     int MFAL_mdZSq2d(int Nx_n,int Ny_n,double* mu_n,int J,double* S,int Q,double* q,double* Z_S_q) 
#endif /* __STDC__ */
{
  if((Nx_n>0)&&(Ny_n>0)&&(mu_n!=NULL)&&(J>0)&&(S!=NULL)&&(Q>0)&&(q!=NULL)&&(Z_S_q!=NULL))
    {
      register int j=0,k=0,lx=0,ly=0;
      double mu_S2d=0;
      for(j=0;j<J;j++)
	{
	  for(k=0;k<Q;k++)
	    {
	      *(Z_S_q+Q*j+k)=0.;
	      for(ly=0;ly<Ny_n;ly+=(int)*(S+j))
		for(lx=0;lx<Nx_n;lx+=(int)*(S+j))
		  {
		    mu_S2d=MFAM_mu_S2d(mu_n+ly*Nx_n+lx,(int)*(S+j),(int)*(S+j),Nx_n);
		    *(Z_S_q+Q*j+k)+=(mu_S2d!=0.?pow(mu_S2d,*(q+k)):0);
		  }
	    }
	}
      return 1;
    }
  else
    {
      fprintf(stderr,"MFAL_mdZSq2d arguments error\n");
      return 0;
    }
}

/*****************************************************************************/

#ifndef __STDC__
int MFAL_mdZq2d(Nx_n, Ny_n, mu_n, t_part, J, S_min, S_max, P_min, P_max, a, Q, q, Z_a_q)
     int Nx_n;
     int Ny_n;
     double* mu_n;
     MFAMt_part t_part;
     short int J;
     double S_min;
     double S_max;
     double P_min;
     double P_max;
     double* a;
     short int Q;
     double* q;
     double* Z_a_q;
#else /* __STDC__ */
     int MFAL_mdZq2d(int Nx_n,int Ny_n,double* mu_n,MFAMt_part t_part,short J,double S_min,double S_max,double P_min,double P_max,double* a,short Q,double* q,double* Z_a_q)
#endif /* __STDC__ */
{
  /**
     Added by Fred :
     je prefere tester les arguments les uns apres les autres pour savoir 
     d'ou vient l'erreur ;-)
   */
  if((Nx_n <= 0) || (Ny_n <= 0)) {
    fprintf(stderr,"MFAL_mdZSq2d error : (Nx_n (%d) <= 0) || (Ny_n (%d) <= 0)\n", Nx_n, Ny_n);
    return 0;
  }
  if (!mu_n) {
    fprintf(stderr,"MFAL_mdZSq2d error : mu_n == NULL :(((\n"); 
    return 0;
  }
  if (J<=0) {
    fprintf(stderr,"MFAL_mdZSq2d error : (J (%d) <= 0)\n",J); 
    return 0;
  }
  if ((S_min<1.) || (S_min > S_max) || (S_max > Nx_n/2.)) {
    fprintf(stderr,"MFAL_mdZSq2d error : (S_min<1.) || (S_min > S_max || (S_max > Nx_n/2.)) \n"); 
    fprintf(stderr,"Smin : (%g)\nSmax : (%g)\nNx_n/2. : (%g)\n",S_min, S_max, Nx_n/2.);
    return 0;
  }
  if (( P_min<1.) || (P_min > P_max) || (P_max > Nx_n/2.)) {
    fprintf(stderr,"MFAL_mdZSq2d error : ( P_min<1.) || (P_min > P_max) || (P_max > Nx_n/2.)\n"); 
    fprintf(stderr,"Pmin : (%g)\nPmax : (%g)\nNx_n/2. : (%g)\n",P_min, P_max, Nx_n/2.);
    return 0;
  }
  if (!a) {
    fprintf(stderr,"MFAL_mdZSq2d error : a == NULL :(((\n"); 
    return 0;
  }
  if (!q) {
    fprintf(stderr,"MFAL_mdZSq2d error : q == NULL :(((\n"); 
    return 0;
  }
  if (Q<=0) {
    fprintf(stderr,"MFAL_mdZSq2d error : Q (%d) <= 0\n",Q); 
    return 0;
  }
  if (!Z_a_q) {
    fprintf(stderr,"MFAL_mdZSq2d error : Z_a_q == NULL :(((\n"); 
    return 0;
  }
  

  if((Nx_n>0)&&(Ny_n>0)&&(mu_n!=NULL)&&(J>0)&&(S_min>=1.)&&(S_min<=S_max)&&(S_max<=Nx_n/2.)&&(P_min>=1.)&&(P_min<=P_max)&&(P_max<=Nx_n/2.)&&(a!=NULL)&&(Q>0)&&(q!=NULL)&&(Z_a_q!=NULL))
    {
      register int j=0;
      if(t_part==MFAM_DECSIZE)
	{
	  double* S=a;
	  if(MFAM_decsizespace(Nx_n,J,S_min,S_max,S)==0) 
	    { 
	      fprintf(stderr,"MFAM_decsizespace error\n");  
	      return 0; 
	    }
	  if(MFAL_mdZSq2d(Nx_n,Ny_n,mu_n,J,S,Q,q,Z_a_q)==0)
	    {
	      fprintf(stderr,"MFAL_mdZSq2d error\n");
	      return 0;
	    } 
	  for(j=0;j<J;j++)
	    *(a+j)=(*(S+j)/S_min);
	  S=NULL;
	}
      else
	{  
	  double* P=a;
	  if(MFAM_partspace(Nx_n,t_part,J,P_min,P_max,P)==0) 
	    { 
	      fprintf(stderr,"MFAM_partspace error\n");  
	      return 0; 
	    }  
	  /*  if(MFAL_mdZPq1d(Nx_n,Ny_n,mu_n,J,P,Q,q,Z_a_q)==0) */
	  /*       { */
	  /* 	fprintf(stderr,"MFAL_mdZPq1d error\n"); */
	  /* 	return 0; */
	  /*       } */
	  for(j=0;j<J;j++)
	    *(a+j)=(P_max/(*(P+j)));
	  P=NULL;
	}
      return 1;
    }
  else
    {
      fprintf(stderr,"MFAL_mdZq2d arguments error\n");
      return 0;
    }
}
