/*-----------------------------------------------------------------------------
*                                                                              
*                                    FracLab
*                                                                              
*------------------------------------------------------------------------------
*                                                                              
* File path        : /home/users/canus/MFA.CMP/MFAM.CL/inc/MFAM_btree.h
* File type        : C header file
* Revision         : $Revision: 1.1.1.1 $
* RCS status       : $Id: MFAM_tree.h,v 1.1.1.1 1999/02/10 13:29:04 guiheneu Exp $
* Created by       : (Fractales Project INRIA) Christophe Canus
* Creation date    : Sun Feb  7 16:05:16 1999
* Last edited by   : (Fractales Project INRIA) Christophe Canus
* Last edition date: Thu Sep 19 14:23:53 2002
*                                                                              
*------------------------------------------------------------------------------
*                                                                              
* Description : 
*                
*                
*                
*------------------------------------------------------------------------------
*/

/* Christophe Canus 1997-98-02 */

#ifndef _MFAM_btree_h_
#define _MFAM_btree_h_
#include "MFAM_include.h"
#include "MFAM_misc.h"
#include "MFAM_stats.h"
#include "MFAM_capacity.h"

typedef enum 
{
  MFAM_CAPACITY=0,
  MFAM_REFERENCE=1,
  MFAM_HOELDER=2,
  MFAM_SET=3
} MFAMt_level;

#define MFAM_CAPACITYSTR "capa"
#define MFAM_REFERENCESTR "ref"
#define MFAM_HOELDERSTR "hoel"
#define MFAM_SETSTR "set"

typedef struct _bnode
{
   char* x;
   short n;
   int   k;
   struct _bnode* lnode;
   struct _bnode* rnode;
} MFAMt_bnode;

typedef struct _btree
{
   short N;
   double** c_level;
   double** r_level;
   double** h_level;
   unsigned char** s_level;
   MFAMt_bnode* root;
} MFAMt_btree;

#ifndef __STDC__ 
MFAMt_bnode* MFAM_bnode_create();
void MFAM_bnode_delete();
void MFAM_bnode_print();
#else /* __STDC__ */
MFAMt_bnode* MFAM_bnode_create(MFAMt_bnode*,char*,short,int,short);
void MFAM_bnode_delete(MFAMt_bnode*);
void MFAM_bnode_print(MFAMt_bnode*,int); 
#endif /* __STDC__ */

#ifndef __STDC__
MFAMt_btree* MFAM_btree_create();
void MFAM_btree_delete();
void MFAM_btree_print();
#else /* __STDC__ */
MFAMt_btree* MFAM_btree_create(short);
void MFAM_btree_delete(MFAMt_btree*);
void MFAM_btree_print(MFAMt_btree*);
#endif /* __STDC__ */

#ifndef __STDC__
int MFAM_btree_level_create();
int MFAM_btree_level_delete();
int MFAM_btree_level_set();
void* MFAM_btree_level_get();
int MFAM_btree_level_print();
#else /* __STDC__ */
int MFAM_btree_level_create(MFAMt_btree*,MFAMt_level,short,short);
int MFAM_btree_level_delete(MFAMt_btree*,MFAMt_level,short,short);
int MFAM_btree_level_set(MFAMt_btree*,MFAMt_level,short,void*);
int MFAM_btree_level_convert(MFAMt_btree*,MFAMt_level,short,int,void*);
void* MFAM_btree_level_get(MFAMt_btree*,MFAMt_level,short);
int MFAM_btree_level_print(MFAMt_btree*,MFAMt_level,short,short);
#endif /* __STDC__ */

#ifndef __STDC__
int MFAM_btree_cprint();
void MFAM_bnode_cprint();
#else /* __STDC__ */
int MFAM_btree_cprint(MFAMt_btree*);
void MFAM_bnode_cprint(MFAMt_bnode*,MFAMt_btree*);
#endif /* __STDC__ */

#ifndef __STDC__
double MFAM_bnode_cget();
void MFAM_bnode_cset();
double MFAM_bnode_rget();
double MFAM_bnode_rset();
#else /* __STDC__ */
double MFAM_bnode_cget(MFAMt_bnode*,MFAMt_btree*);
void MFAM_bnode_cset(MFAMt_bnode*,MFAMt_btree*,double);
double MFAM_bnode_rget(MFAMt_bnode*,MFAMt_btree*);
double MFAM_bnode_rset(MFAMt_bnode*,MFAMt_btree*,double);
#endif /* __STDC__ */

#ifndef __STDC__
void MFAM_bnode_hprint();
int MFAM_btree_hprint();
int MFAM_btree_h_levelprint();
#else /* __STDC__ */
void MFAM_bnode_hprint(MFAMt_bnode*,MFAMt_btree*,short,short);
int MFAM_btree_hprint(MFAMt_btree*,short,short);
int MFAM_btree_h_levelprint(MFAMt_btree*,short);
#endif /* __STDC__ */

#ifndef __STDC__
double MFAM_bnode_c_level_decimate();
int MFAM_btree_c_level_decimate();
double MFAM_bnode_r_level_decimate();
int MFAM_btree_r_level_decimate();
#else /* __STDC__ */
double MFAM_bnode_c_level_decimate(MFAMt_bnode*,MFAMt_btree*,double (*)(double,double),short,short);
int MFAM_btree_c_level_decimate(MFAMt_btree*,MFAMt_capa,short,short);
double MFAM_bnode_r_level_decimate(MFAMt_bnode*,MFAMt_btree*,short,short);
int MFAM_btree_r_level_decimate(MFAMt_btree*,short,short);
#endif /* __STDC__ */

#ifndef __STDC__
MFAMt_btree* MFAM_btree_binomial();
void MFAM_bnode_binomial();
#else /* __STDC__ */
MFAMt_btree* MFAM_btree_binomial(short,double);
void MFAM_bnode_binomial(MFAMt_bnode*,MFAMt_btree*,double,double);
#endif /* __STDC__ */

#endif /* _MFAM_btree_h_ */
