/*-----------------------------------------------------------------------------
*                                                                              
*                                    FracLab
*                                                                              
*------------------------------------------------------------------------------
*                                                                              
* File path        : /home/canus/MFA.CMP/MFAM.CL/src/MFAM_density.c
* File type        : C source file
* Revision         : $Revision: 1.1.1.1 $
* RCS status       : $Id: MFAM_density.c,v 1.1.1.1 1999/02/10 13:29:04 guiheneu Exp $
* Created by       : (Fractales Project INRIA) Christophe Canus
* Creation date    : Sun Feb  7 15:56:37 1999
* Last edited by   : (Fractales Project INRIA) Christophe Canus
* Last edition date: Sun Feb  7 15:56:38 1999
*                                                                              
*------------------------------------------------------------------------------
*                                                                              
* Description : 
*                
*                
*                
*------------------------------------------------------------------------------
*/

/* Christophe Canus 1997-98 */

#include "MFAM_density.h" 

/*****************************************************************************/

int MFAM_kpdf(int n,double* n_sample,MFAMt_kern t_kern,int N,double* h,MFAMt_width t_width,double* x,double* p_x)
{
  if((n>0)&&(n_sample!=NULL)&&(N>0)&&(h!=NULL)&&(x!=NULL)&&(p_x!=NULL))
  { 
    register int k=0;
    static int (*compare)()=MFAM_compare; 
#ifndef __STDC__
    double (*kern)()=NULL; 
#else /*   __STDC__ */
    double (*kern)(double)=NULL;  
#endif /*   __STDC__ */
    qsort(n_sample,n,sizeof(double),compare);  
    if(MFAM_linspace(N,*n_sample,*(n_sample+n-1),x)==0)
    {
      fprintf(stderr,"MFAM_linspace error\n");
      return 0;
    } 
    switch(t_kern)
    {  
      case MFAM_BOXCAR:
        kern=MFAM_boxcar;
	break; 
      case MFAM_TRIANGLE:
	kern=MFAM_triangle;
	break; 
      case MFAM_GAUSSIAN:
	kern=MFAM_gauss;
	break;
      case MFAM_MOLLIFIER:
	kern=MFAM_mol;
	break; 
      case MFAM_EPANECHNIKOV:
	kern=MFAM_epa;
	break; 
      case MFAM_QUARTIC:
        kern=MFAM_quartic;
	break;   
      case MFAM_INTEGRATED:
      default:
        fprintf(stderr,"MFAM_kpdf arguments error\n");
        return 0;
    }
    if(MFAM_iszeros(N,h)==1)
    {
      if(MFAM_adaption(n,n_sample,0,NULL,kern,N,h,t_width,x,p_x)==0)
      {
	fprintf(stderr,"MFAM_adaption error\n");
	return 0;
      }
    }
    for(k=0;k<N;k++)
    {
      if(MFAM_kernelconvolve(n,n_sample,*(h+k),kern,N,k,x+k,p_x+k)==0)
      {
	fprintf(stderr,"MFAM_kernelconvolve error\n");
	return 0;
      }
    }
    return 1;
  }
  else
  {
    fprintf(stderr,"MFAM_kpdf arguments error\n");
    return 0;   
  }
}
