/*-----------------------------------------------------------------------------
*                                                                              
*                                    FracLab
*                                                                              
*------------------------------------------------------------------------------
*                                                                              
* File path        : /home/canus/MFA.CMP/MFAM.CL/inc/MFAM_measure.h
* File type        : C header file
* Revision         : $Revision: 1.1.1.1 $
* RCS status       : $Id: MFAM_measure.h,v 1.1.1.1 1999/02/10 13:29:04 guiheneu Exp $
* Created by       : (Fractales Project INRIA) Christophe Canus
* Creation date    : Sun Feb  7 16:06:12 1999
* Last edited by   : (Fractales Project INRIA) Christophe Canus
* Last edition date: Sun Feb  7 16:06:13 1999
*                                                                              
*------------------------------------------------------------------------------
*                                                                              
* Description : 
*                
*                
*                
*------------------------------------------------------------------------------
*/

/* Christophe Canus 1997-98 */

#ifndef _MFAS_measure_h_
#define _MFAS_measure_h_
#include "MFAM_include.h"

typedef enum
{
  MFAM_ASYMMETRIC=0,
  MFAM_STAR=1,
  MFAM_CENTERED=2
} MFAMt_ball;

#define MFAM_ASYMMETRICSTR "asym"
#define MFAM_STARSTR "star"
#define MFAM_CENTEREDSTR "cent"

#ifndef __STDC__
extern int MFAM_ballstr();
#else /* __STDC__ */
extern int MFAM_ballstr(char*,MFAMt_ball*);
#endif /* __STDC__ */

typedef enum
{
  MFAM_NOBORD=0,
  MFAM_MIRROR=1,
  MFAM_PERIOD=2,
} MFAMt_bord;

#define MFAM_NOBORDSTR "nobord"
#define MFAM_MIRRORSTR "mir"
#define MFAM_PERIODSTR "per"

#ifndef __STDC__ 
extern int MFAM_bordstr();
#else /* __STDC__ */
extern int MFAM_bordstr(char*,MFAMt_bord*);
#endif /* __STDC__ */

#ifndef __STDC__
extern double MFAM_mu_S1d();
extern double MFAM_mu_S2d();
#else /* __STDC__ */
extern double MFAM_mu_S1d(double*,int);
extern double MFAM_mu_S2d(double*,int,int,int);
#endif /* __STDC__ */

#ifndef MFAM_MEASURE_CPP
extern int FRflg;
#else
int FRflg;
#endif

#ifndef __STDC__
extern double MFAM_mu_P1d();
extern double MFAM_mu_2_n_x();
extern double MFAM_mu_star_2_n_x();
extern double MFAM_mu_n_x();
extern double MFAM_mu_eta();
extern double MFAM_mu_eta_x();
extern double MFAM_mu_eta_star_x();
extern double MFAM_mu_eta_c_x();
extern double MFAM_mu_eta_b_x();
#else /* __STDC__ */
extern double MFAM_mu_P1d(int,double*,int);
extern double MFAM_mu_2_n_x(short,double*,double*,double,int);
extern double MFAM_mu_star_2_n_x(short,double*,double*,double);
extern double MFAM_mu_n_x(int,double*,double*,double);
extern double MFAM_mu_eta(int,double*,int,double);
extern double MFAM_mu_eta_x(int,double*,double*,double,double,double,double);
extern double MFAM_mu_eta_star_x(int,double*,double*,double,double,double,double);
extern double MFAM_mu_eta_c_x(int,double*,double*,double,double,double,double);
extern double MFAM_mu_eta_b_x(int,double*,double*,double,double,double,double,MFAMt_ball,MFAMt_bord);
#endif /* __STDC__ */

#endif /*_MFAS_measure_h_*/
