/*-----------------------------------------------------------------------------
*                                                                              
*                                    FracLab
*                                                                              
*------------------------------------------------------------------------------
*                                                                              
* File path        : /home/users/canus/MFA.CMP/MFAM.CL/inc/MFAM_misc.h
* File type        : C header file
* Revision         : $Revision: 1.1.1.1 $
* RCS status       : $Id: MFAM_misc.h,v 1.1.1.1 1999/02/10 13:29:04 guiheneu Exp $
* Created by       : (Fractales Project INRIA) Christophe Canus
* Creation date    : Sun Feb  7 16:06:09 1999
* Last edited by   : (Fractales Project INRIA) Christophe Canus
* Last edition date: Sun Nov 17 19:16:37 2002
*                                                                              
*------------------------------------------------------------------------------
*                                                                              
* Description : 
*                
*                
*                
*------------------------------------------------------------------------------
*/

/* Christophe Canus 1997-98 */

#ifndef _MFAM_misc_h_
#define _MFAM_misc_h_
#include "MFAM_include.h"

#ifndef __STDC__
int MFAM_compare();
int MFAM_base();
int MFAM_zeros();
int MFAM_isempty();
int MFAM_iszeros();
int MFAM_linspace();
int MFAM_logspace();
int MFAM_decspace();
#else /* __STDC__ */
int MFAM_compare(double*,double*);
int MFAM_base(int,short*);
int MFAM_zeros(int,double*);
int MFAM_isempty(int,unsigned char*);
int MFAM_iszeros(int,double*);
int MFAM_linspace(int,double,double,double*);
int MFAM_logspace(int,double,double,double*);
int MFAM_decspace(int,int,double,double,double*);
#endif /* __STDC__ */

typedef enum
{ 
  MFAM_LIN=0,
  MFAM_LOG=1,
  MFAM_DEC=2
} MFAMt_prog;

#define MFAM_DECSTR "dec"
#define MFAM_LINSTR "lin"
#define MFAM_LOGSTR "log"

#ifndef __STDC__
int MFAM_progstr();
int MFAM_scale();
#else /* __STDC__ */
int MFAM_progstr(char*,MFAMt_prog*);
int MFAM_scale(int,double,double,short,double*,MFAMt_prog,int);
#endif /* __STDC__ */

typedef enum
{
  MFAM_DECSIZE=0,
  MFAM_LINPART=1,
  MFAM_LOGPART=2,
  MFAM_DECPART=3
} MFAMt_part;

#define MFAM_DECSIZESTR "decsize"
#define MFAM_LINPARTSTR "linpart"
#define MFAM_LOGPARTSTR "logpart"
#define MFAM_DECPARTSTR "decpart"

#ifndef __STDC__
int MFAM_partstr();
int MFAM_partspace();
int MFAM_decsizespace();
int MFAM_bilogspace();
int MFAM_weights();
int MFAM_weights2d();
int MFAM_min_max();
int MFAM_min_max_dev();
int MFAM_min_dev();
int MFAM_max_dev();
int MFAM_mean_dev();
int MFAM_norm();
#else /* __STDC__ */
int MFAM_partstr(char*,MFAMt_part*);
int MFAM_partspace(int,MFAMt_part,int,double,double,double*);
int MFAM_decsizespace(int,int,double,double,double*);
int MFAM_bilogspace(int,short,double,double,double*);
int MFAM_weights(short,double*);
int MFAM_weights2d(short,short,double*);
int MFAM_min_max(int,double*,double*,double*);
int MFAM_min_max_dev(int,double*,double*,double*);
int MFAM_min_dev(int,double*,double*);
int MFAM_max_dev(int,double*,double*);
int MFAM_mean_dev(int,double*,double*);
int MFAM_norm(int,double*,double*,int);
#endif /* __STDC__ */

#if defined(_MSC_VER)

#else /* defined(_MSC_VER) */
#include <sys/time.h>
#ifndef __STDC__
int MFAM_progress();
#else /* __STDC__ */
int MFAM_progress(int k, int N);
#endif /* __STDC__ */
#endif /* defined(_MSC_VER) */

#endif /*_MFAM_misc_h_*/
