/*-----------------------------------------------------------------------------
*                                                                              
*                                    FracLab
*                                                                              
*------------------------------------------------------------------------------
*                                                                              
* File path        : /home/users/canus/MFA.CMP/MFAM.CL/src/MFAM_random.c
* File type        : C source file
* Revision         : $Revision: 1.1.1.1 $
* RCS status       : $Id: MFAM_random.c,v 1.1.1.1 1999/02/10 13:29:04 guiheneu Exp $
* Created by       : (Fractales Project INRIA) Christophe Canus
* Creation date    : Sun Feb  7 15:54:27 1999
* Last edited by   : (Fractales Project INRIA) Christophe Canus
* Last edition date: Wed Sep  4 15:49:31 2002
*                                                                              
*------------------------------------------------------------------------------
*                                                                              
* Description : 
*                
*                
*                
*------------------------------------------------------------------------------
*/

/* Christophe Canus 1996-97-98 */

#include "MFAM_random.h"

int seed;
static double normal_1(void);

/* random seed */
void random_seed(void) 
{
  time_t t=0;
  time(&t);
  seed=t;
  srand(seed);
}

/* normal r.v. with expected value 0. and variance 1.*/
static double normal_1(void) 
{
  double u=0.,v=1.,w=0.;
  u=rand()/(RAND_MAX+1.);
  u=M_PI*(u-0.5);
  while(v==1.)
    v=rand()/(RAND_MAX+1.);
  v=-log(1.-v);
  w=sqrt(2*v)*sin(u);
  return(w);
}

/* uniform r.v. in [a,b] */
double MFAM_uniform(double a,double b)
{
  return (a+b)*.5+(rand()/(RAND_MAX+1.)-.5)*(b-a);
}

/* Rayleigh r.v.*/
double MFAM_Rayleigh(double c) 
{
  return sqrt((double)(-2.*c*c)*log((double)(1.-rand()/(RAND_MAX+1.))));
}

/* normal r.v. with mean 0. and variance sigma_2 */
double MFAM_normal(double m,double sigma_2) 
{    
  return m+sigma_2*normal_1();
}

/* lognormal r.v with mean m and variance sigma_2 */
double MFAM_lognormal(double m,double sigma_2)
{ 
  return exp((double)MFAM_normal(m,sigma_2));
}

/*****************************************************************************/

int MFAM_shuffle(int data_nb,double *data)
{
  if((data_nb>0)&&(data!=NULL))
  {
    int k=data_nb-1,tmp_k=0;
    register int l=0;
    double tmp_data=0.;  
    time_t time_seed=time(NULL);
    srand((unsigned int)time_seed);
    while(k>=0)
    {
      tmp_k=MFAM_uniform_integer(k+1);
      tmp_data=*(data+tmp_k);  
      for(l=tmp_k;l<k;l++)
	*(data+l)=*(data+l+1);
      *(data+k)=tmp_data;
      k--;  
    } 
    return 1;
  }
  else
  {
    fprintf(stderr,"MFAM_shuffle arguments error\n");
    return 0;
  }
}

/*****************************************************************************/

int MFAM_uniform_integer(int N)
{
  return (int)(N*(double)rand()/((double)RAND_MAX));
}

/*****************************************************************************/

unsigned char MFAM_bernouilli(double p)
{
  unsigned char bernouilli=(unsigned char)((double)rand()/(RAND_MAX+1.)>=p?1:0);
  return bernouilli;
}    
  
