/*-----------------------------------------------------------------------------
*                                                                              
*                                    FracLab
*                                                                              
*------------------------------------------------------------------------------
*                                                                              
* File path        : /home/canus/MFA.CMP/MFAS.CL/src/MFAS_weierstrass.c
* File type        : C source file
* Revision         : $Revision: 1.1.1.1 $
* RCS status       : $Id: MFAS_weierstrass.c,v 1.1.1.1 1999/02/10 13:43:28 guiheneu Exp $
* Created by       : (Fractales Project INRIA) Christophe Canus
* Creation date    : Sun Feb  7 16:13:03 1999
* Last edited by   : (Fractales Project INRIA) Christophe Canus
* Last edition date: Sun Feb  7 16:13:04 1999
*                                                                              
*------------------------------------------------------------------------------
*                                                                              
* Description : 
*                
*                
*                
*------------------------------------------------------------------------------
*/

#include "MFAS_weierstrass.h"

/*****************************************************************************/

int MFAS_wf(short n,double lambda,double H,int N,double* x,double* wf_x,int rflg)
{
  if((n>0)&&(lambda>1.)&&(0.<H)&&(H<1.)&&(N>0)&&(x!=NULL)&&(wf_x!=NULL))
  {
    register int k=0,l=0;
    double lambda_pow_k=0.,lambda_pow_minus_k=0.,phi_k=0.; 
    if(rflg)
    {
      time_t time_seed=time(NULL);
      srand((unsigned int)time_seed);
    }
    for(k=1;k<n;k++)
    {
      lambda_pow_k=(double)pow(lambda,(double)k);
      lambda_pow_minus_k=(double)pow(lambda,-(double)k);
      if(rflg)
	phi_k=2*3.1416*MFAM_uniform(0,1);
      for(l=0;l<N;l++)
	*(wf_x+l)+=(double)pow(lambda_pow_minus_k,H)*sin(2*3.1416*lambda_pow_k**(x+l)+phi_k);
    }
    return 1;
  }
  else
  { 
    fprintf(stderr,"MFAS_wf arguments error\n");
    return 0;
  }
}
