/* The program culloch.c estimates parameters (alpha,beta,mu,gamma)*/
/* of a stable law using the Mc-Culloch method                     */
#include "McCulloch.h"
#include <stdio.h>
#include <stdlib.h>
#include <math.h>

/********************************************************************/
/********************** calcul de la moyenne empirique **************/


double      stable_E(double  *tab, int n)
{
        int        i;
        double     som = 0.0;

        for (i=0; i<n; i++){

                som += tab[i];
        }
        return(som / n);              
}
	     
/********************************************************************/
/********************************************************************/

void        stable_sort(int n, double *tab)
{
        int       i, j;
        double    a;

        for (j = 1; j < n; j++) {
                a=tab[j];
                i=j-1;
                while (i >= 0 && tab[i] > a ){
                        tab[i+1]=tab[i];
                        i--;
                }
                tab[i+1]=a;
        }
}

/********************************************************************/
/********************************************************************/

void stable_bilint(double x1a[], double x2a[], double **ya, int n, int m, 
	    double x1, double x2, double *y)

{
  int      j,k;
  double   y1, y2, y3, y4, t, u;
  for (j=0;j<n-1;j++){
    if((x1 >= x1a[j]) && (x1 <= x1a[j+1])){
      for (k=0;k<m-1;k++){
	if((x2 >= x2a[k]) && (x2 <= x2a[k+1])){
	  y1 = ya[j][k];
	  y2 = ya[j+1][k];
	  y3 = ya[j+1][k+1];
	  y4 = ya[j][k+1];
	  t  = (x1-x1a[j])/(x1a[j+1]-x1a[j]);
	  u  = (x2-x2a[k])/(x2a[k+1]-x2a[k]);

	  *y = ((1.0-t)*(1.0-u)*y1)+(t*(1.0-u)*y2)+(t*u*y3)+((1.0-t)*u*y4);
	}
      }
    }
  }
}

/********************************************************************/
