/*-----------------------------------------------------------------------------
*                                                                              
*                                    FracLab
*                                                                              
*------------------------------------------------------------------------------
*                                                                              
* File path        : /a/linoleum.2/FRACLAB/SRC-DEV/INA/TML/SRC/dtmlp.c
* File type        : C source file
* Revision         : $Revision: 1.2 $
* RCS status       : $Id: dtmlp.c,v 1.2 2001/01/31 15:12:20 raynal Exp $
* Created by       : (Fractales Project INRIA) Kiran Kolwankar
* Creation date    : Oct 2000
* Last edited by   : (Fractales Project INRIA) Kiran Kolwankar
* Last edition date: Jan 9 2001
*                                                                              
*------------------------------------------------------------------------------
*                                                                              
* Description : 
*                
*                
*                
*------------------------------------------------------------------------------
*/

/* Kiran Kolwankar 2001 */

#include <math.h>

#define max(x,y) ((x > y) ? x : y)

/* double dabs(double x)
{
if (x < 0) return(-x);
return(x);
} 

double max(double x,double y)
{
if (x < y) return(y);
return(x);
} */

#define N_constant 16384 /* 16*1024*/
void dtmlp(double *fnw, int M,int N,int n_total,int incr,double *he,double *len)
{

   int isp, is,lendiffmax, j12, in;
   int length1, length2, length3, length4;
   int lendiff1, lendiff2, lendiff3, lendiff4;
   int i1, i2, j1, j3, j4, sp12, s12;
   double sp, s_cr, s;
   double s_incr = 0.01;
   double sp_incr = 0.1;
   double normdiff, tmpmax;
   double fn[N_constant];
   double norm[N_constant/2][2];
   double slope[101][3];
   int nr = N-1;
   int nby2 = N/2;
   int im = 0;
   int n_iter = 1;

   while(((im*incr)+N <= M) && (n_iter <= n_total))
   {
      n_iter++;
      for(i2=0; i2 <= N-1; i2++)
      {
	 fn[i2] = fnw[i2+im*incr];
      }
   isp = 0;
/*   for(sp = 1.0; sp >= -1.0; sp -= sp_incr) */
   {
      is = 0;
      lendiff1 = 0;
      lendiff2 = 0;
      lendiff3 = 0;
      lendiff4 = 0;
      length1 = 0;
      length2 = 0;
      length3 = 0;
      length4 = 0;
      lendiffmax = 0;
      s_cr = 0.0;
      s = 0.0;
      do
      {
         sp = -s;
         tmpmax = 0;
         j12 = 0;
         for(j1 = 1; j1 < nr/2; j1++)
	 {
	    
	    for(j3 = 1; j3 <= 2*j1; j3++)
	    {
	       double absfn1 = j3;
               double absfn11 = abs(j3-j1);
               double absfn12 = j1;
               double array = fabs(fn[nby2-j1+j3] - fn[nby2-j1])/
			  (exp(log(absfn1)*s))/ 
			  (exp(log(1+absfn11/absfn1)*(-sp/2)))/ 
			  (exp(log(1+absfn12/absfn1)*(-sp/2)));
	       tmpmax = max(tmpmax, array);
	    }
	    for(j4 = 1; j4 <= 2*j1-1; j4++)
	    {
	       double absfn1 = j4;
               double absfn11 = j1;
               double absfn12 = abs(j1-j4);
               double array = fabs(fn[nby2+j1] - fn[nby2+j1-j4])/ 
			  (exp(log(absfn1)*s))/ 
			  (exp(log(1+absfn11/absfn1)*(-sp/2)))/ 
			  (exp(log(1+absfn12/absfn1)*(-sp/2)));
	       tmpmax = max(tmpmax, array);
	    }
            norm[j12][0] = j1;
	    norm[j12][1] = tmpmax;
	    j12 = j12 + 1;
	 }
	 in = 0;
	 do
	 {
	 in++;
	 normdiff = norm[j12-1][1] - norm[j12-1-in][1];
	 }
	 while(normdiff <= 0.00001);
         len[is] = in;
	 lendiff3 = in - length3;
	 if (lendiff3 >= 0) length3 = length2;
	 lendiff2 = in - length2;
	 if (lendiff2 >= 0) length2 = length1;
	 lendiff1 = in - length1;
	 if (lendiff1 >= 0) length1 = in;
	 if (lendiff1 > lendiffmax && is > 0)
	 {
	 lendiffmax = lendiff1;
	 s_cr = s;
	 }
	 if (lendiff2 > lendiffmax && is > 1)
	 {
	 lendiffmax = lendiff2;
	 s_cr = s - s_incr;
	 }
	 if (lendiff3 > lendiffmax && is > 2)
	 {
	 lendiffmax = lendiff3;
	 s_cr = s - 2*s_incr;
	 }
	 is++;
	 s += s_incr;
      } 
      while(s <= 1.0);
/*      he[isp][0] = sp; */
      he[im] = s_cr;
      isp++;
   }
      im++;
   }
/*   for(sp12 = 0; sp12 <= isp-1; sp12++)
   {
      for(s12 = 0; s12 <= im; s12++)
      cout << he[sp12][s12] <<" ";
      cout <<"\n";
   } */
}
