#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "stable_cov.h"
#include "stable_sm.h"
#ifndef sign
#define sign(z) (z<0 ? (-1.0) : (1.0))
#endif

#ifndef M_PI
#define M_PI  3.1415926535
#endif

/****************************************************************************/
 /*estimation empirique de la fonction de distribution de la mesure spectrale*/

double  stable_dspect(double *X,double *Y, int size, double t, double *Z,int k,double alpha)
{
 
	int        i;
	double som = 0.0;

	for (i=0;i<size;i++)
	  {

	  if ((stable_arg(X,Y,i) <= t)
	      && (stable_modu(X,Y,i) >= Z[size-k+1]))
	    som += 1.0 ;
	
	  }
	
	return ((double) (som * pow(Z[size-k],alpha)/size));
}


/*****************************************************************************/
/********************estimation de la covariation*****************************/


double stable_cov(double *X,double *Y,int size,double *Z,int k,double alpha)
{

	int        l, p=100;
	double     som=0.0;
	double     t,t1;
	for (l=0;l< (p+1);l++){
	  t = 2.0*l*M_PI/(p+1);
	  t1= 2.0*(l+1)*M_PI/(p+1);
	  som+= (cos(t))*pow(abs(sin(t)),(alpha-1.0))*sign(sin(t))
	    *(stable_dspect(X,Y,size,t1,Z,k,alpha)
	      - stable_dspect(X,Y,size,t,Z,k,alpha));
			
	}
	return((double) som);
	  	      
}
/**********************************************************************/
/**********************************************************************/






