/* This Software is ( Copyright INRIA . 1998 1999 1 )                */
/*                                                                   */
/* INRIA  holds all the ownership rights on the Software.            */
/* The scientific community is asked to use the SOFTWARE             */
/* in order to test and evaluate it.                                 */
/*                                                                   */
/* INRIA freely grants the right to use modify the Software,         */
/* integrate it in another Software.                                 */
/* Any use or reproduction of this Software to obtain profit or      */
/* for commercial ends being subject to obtaining the prior express  */
/* authorization of INRIA.                                           */
/*                                                                   */
/* INRIA authorizes any reproduction of this Software.               */
/*                                                                   */
/*    - in limits defined in clauses 9 and 10 of the Berne           */
/*    agreement for the protection of literary and artistic works    */
/*    respectively specify in their paragraphs 2 and 3 authorizing   */
/*    only the reproduction and quoting of works on the condition    */
/*    that :                                                         */
/*                                                                   */
/*    - "this reproduction does not adversely affect the normal      */
/*    exploitation of the work or cause any unjustified prejudice    */
/*    to the legitimate interests of the author".                    */
/*                                                                   */
/*    - that the quotations given by way of illustration and/or      */
/*    tuition conform to the proper uses and that it mentions        */
/*    the source and name of the author if this name features        */
/*    in the source",                                                */
/*                                                                   */
/*    - under the condition that this file is included with          */
/*    any reproduction.                                              */
/*                                                                   */
/* Any commercial use made without obtaining the prior express       */
/* agreement of INRIA would therefore constitute a fraudulent        */
/* imitation.                                                        */
/*                                                                   */
/* The Software beeing currently developed, INRIA is assuming no     */
/* liability, and should not be responsible, in any manner or any    */
/* case, for any direct or indirect dammages sustained by the user.  */
/*                                                                   */
/* Any user of the software shall notify at INRIA any comments       */
/* concerning the use of the Sofware (e-mail : FracLab@inria.fr)     */
/*                                                                   */
/* This file is part of FracLab, a Fractal Analysis Software         */

/* This Software is ( Copyright INRIA . 1998 1999 1 )                */
/*                                                                   */
/* INRIA  holds all the ownership rights on the Software.            */
/* The scientific community is asked to use the SOFTWARE             */
/* in order to test and evaluate it.                                 */
/*                                                                   */
/* INRIA freely grants the right to use modify the Software,         */
/* integrate it in another Software.                                 */
/* Any use or reproduction of this Software to obtain profit or      */
/* for commercial ends being subject to obtaining the prior express  */
/* authorization of INRIA.                                           */
/*                                                                   */
/* INRIA authorizes any reproduction of this Software.               */
/*                                                                   */
/*    - in limits defined in clauses 9 and 10 of the Berne           */
/*    agreement for the protection of literary and artistic works    */
/*    respectively specify in their paragraphs 2 and 3 authorizing   */
/*    only the reproduction and quoting of works on the condition    */
/*    that :                                                         */
/*                                                                   */
/*    - "this reproduction does not adversely affect the normal      */
/*    exploitation of the work or cause any unjustified prejudice    */
/*    to the legitimate interests of the author".                    */
/*                                                                   */
/*    - that the quotations given by way of illustration and/or      */
/*    tuition conform to the proper uses and that it mentions        */
/*    the source and name of the author if this name features        */
/*    in the source",                                                */
/*                                                                   */
/*    - under the condition that this file is included with          */
/*    any reproduction.                                              */
/*                                                                   */
/* Any commercial use made without obtaining the prior express       */
/* agreement of INRIA would therefore constitute a fraudulent        */
/* imitation.                                                        */
/*                                                                   */
/* The Software beeing currently developed, INRIA is assuming no     */
/* liability, and should not be responsible, in any manner or any    */
/* case, for any direct or indirect dammages sustained by the user.  */
/*                                                                   */
/* Any user of the software shall notify at INRIA any comments       */
/* concerning the use of the Sofware (e-mail : FracLab@inria.fr)     */
/*                                                                   */
/* This file is part of FracLab, a Fractal Analysis Software         */



#include "C_LAB_Interf.h" 
#include "getDecOscCon.h"
#include <math.h>

/*=============================================
	[CondOsc,SignalOsc]=getDecOscCon( Signal, window, subwindow, binwidth )
	
 =============================================*/

void
LAB_getDecOscCon()
{
	int 	status, m, n;
	int 	sizeCO;
	double 	*CondOsc, *Signal, *SignalOsc;
	long 	sizeSignal,HSig,WSig;
	int  	WinWidth,SubWinWidth,
	 	DecFactor;
	double BinWidth;

	Matrix  *mSignal,
	 	*mWin,
		*mSubWin,
		*mBinWidth,
		*mCO,
		*mSignalOsc;


	mSignal = (Matrix *)( Interf.Param[0] );
	mWin = (Matrix *)( Interf.Param[1] );
	mSubWin = (Matrix *)( Interf.Param[2] );
	mBinWidth = (Matrix *)( Interf.Param[3] );
	
	
	/*==Check Inputs and Outputs==*/


	/* Check # of inputs and outputs */
	if(Interf.NbParamIn != 4) {
	
	 	   InterfError("getDecOscCon:  Four inputs required.");
		   return;

	}
	else if (Interf.NbParamOut > 2)  {
		
		   InterfError("getDecOscCon:  Only two outputs are allowed.");
		   return;
	}

	/* Check types of arguments */
		   
	/*  Check windows */
	if( !( MatrixIsScalar(mWin) && MatrixIsScalar(mSubWin) ) ) {

	        InterfError("getDecOscCon: Window and SubWindow must each be a positive scalar.");
		return;
	}
	WinWidth = (int) floor( MatrixGetScalar(mWin) );
	SubWinWidth = (int) floor(  MatrixGetScalar(mSubWin) );
	if( !( (WinWidth > 0) && (SubWinWidth > 0) ) )   {
	        InterfError("getDecOscCon: Window and SubWindow must each be a positive integer.");
		return;
	}

	/* Check input Signal */
	if( !( MatrixIsNumeric(mSignal) && MatrixIsReal(mSignal) ) ) {
	        InterfError("getDecOscCon: Input Signal must be a real 1 dim Matrix.");
		return;
	}
	Signal = MatrixGetPr( mSignal );
	HSig = MatrixGetHeight( mSignal );
	WSig = MatrixGetWidth( mSignal );
	if( MIN( HSig,WSig ) != 1 ) {
	        InterfError("getDecOscCon: Input Signal must be a real 1 dim Matrix.");
		return;
	}

	sizeSignal =  MAX( HSig, WSig );
	
 	/* Check BinWidth */
	if( !( MatrixIsScalar(mBinWidth) ) ) {
	        InterfError("getDecOscCon: BinWidth must be a positive scalar.");
		return;
	}
	BinWidth = MatrixGetScalar( mBinWidth );
	if( !(BinWidth > 0) ) {
	        InterfError("getDecOscCon: BinWidth must be a positive scalar.");
		return;
	}

	sizeCO=ceil(1.0/BinWidth);
	mCO = MatrixCreate( sizeCO,sizeCO, "real" );
	
	CondOsc = MatrixGetPr(mCO);
	/*THIS GIVES ONE MORE THAN NECESSARY, I STEAL IT BACK LATER*/
	mSignalOsc = MatrixCreate(sizeSignal-WinWidth+1, 1, "real" );
	SignalOsc = MatrixGetPr(mSignalOsc);
	getDecOscCon(Signal, sizeSignal, SignalOsc, CondOsc, sizeCO, 
	             WinWidth, SubWinWidth, BinWidth);
	
	
	ReturnParam(mCO);
	ReturnParam(mSignalOsc);
}


